]> Git Repo - J-u-boot.git/blame_incremental - Makefile
arm: kirkwood: GoFlex Home: Add DM SATA configs
[J-u-boot.git] / Makefile
... / ...
CommitLineData
1# SPDX-License-Identifier: GPL-2.0+
2
3VERSION = 2021
4PATCHLEVEL = 10
5SUBLEVEL =
6EXTRAVERSION = -rc1
7NAME =
8
9# *DOCUMENTATION*
10# To see a list of typical targets execute "make help"
11# More info can be located in ./README
12# Comments in this file are targeted only to the developer, do not
13# expect to learn how to build the kernel reading this file.
14
15# Do not use make's built-in rules and variables
16# (this increases performance and avoids hard-to-debug behaviour)
17MAKEFLAGS += -rR
18
19# Determine target architecture for the sandbox
20include include/host_arch.h
21ifeq ("", "$(CROSS_COMPILE)")
22 MK_ARCH="${shell uname -m}"
23else
24 MK_ARCH="${shell echo $(CROSS_COMPILE) | sed -n 's/^\s*\([^\/]*\/\)*\([^-]*\)-\S*/\2/p'}"
25endif
26unexport HOST_ARCH
27ifeq ("x86_64", $(MK_ARCH))
28 export HOST_ARCH=$(HOST_ARCH_X86_64)
29else ifneq (,$(findstring $(MK_ARCH), "i386" "i486" "i586" "i686"))
30 export HOST_ARCH=$(HOST_ARCH_X86)
31else ifneq (,$(findstring $(MK_ARCH), "aarch64" "armv8l"))
32 export HOST_ARCH=$(HOST_ARCH_AARCH64)
33else ifneq (,$(findstring $(MK_ARCH), "arm" "armv7" "armv7l"))
34 export HOST_ARCH=$(HOST_ARCH_ARM)
35else ifeq ("riscv32", $(MK_ARCH))
36 export HOST_ARCH=$(HOST_ARCH_RISCV32)
37else ifeq ("riscv64", $(MK_ARCH))
38 export HOST_ARCH=$(HOST_ARCH_RISCV64)
39endif
40undefine MK_ARCH
41
42# Avoid funny character set dependencies
43unexport LC_ALL
44LC_COLLATE=C
45LC_NUMERIC=C
46export LC_COLLATE LC_NUMERIC
47
48# Avoid interference with shell env settings
49unexport GREP_OPTIONS
50
51# We are using a recursive build, so we need to do a little thinking
52# to get the ordering right.
53#
54# Most importantly: sub-Makefiles should only ever modify files in
55# their own directory. If in some directory we have a dependency on
56# a file in another dir (which doesn't happen often, but it's often
57# unavoidable when linking the built-in.o targets which finally
58# turn into vmlinux), we will call a sub make in that other dir, and
59# after that we are sure that everything which is in that other dir
60# is now up to date.
61#
62# The only cases where we need to modify files which have global
63# effects are thus separated out and done before the recursive
64# descending is started. They are now explicitly listed as the
65# prepare rule.
66
67# Beautify output
68# ---------------------------------------------------------------------------
69#
70# Normally, we echo the whole command before executing it. By making
71# that echo $($(quiet)$(cmd)), we now have the possibility to set
72# $(quiet) to choose other forms of output instead, e.g.
73#
74# quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
75# cmd_cc_o_c = $(CC) $(c_flags) -c -o $@ $<
76#
77# If $(quiet) is empty, the whole command will be printed.
78# If it is set to "quiet_", only the short version will be printed.
79# If it is set to "silent_", nothing will be printed at all, since
80# the variable $(silent_cmd_cc_o_c) doesn't exist.
81#
82# A simple variant is to prefix commands with $(Q) - that's useful
83# for commands that shall be hidden in non-verbose mode.
84#
85# $(Q)ln $@ :<
86#
87# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
88# If KBUILD_VERBOSE equals 1 then the above command is displayed.
89#
90# To put more focus on warnings, be less verbose as default
91# Use 'make V=1' to see the full commands
92
93ifeq ("$(origin V)", "command line")
94 KBUILD_VERBOSE = $(V)
95endif
96ifndef KBUILD_VERBOSE
97 KBUILD_VERBOSE = 0
98endif
99
100ifeq ($(KBUILD_VERBOSE),1)
101 quiet =
102 Q =
103else
104 quiet=quiet_
105 Q = @
106endif
107
108# If the user is running make -s (silent mode), suppress echoing of
109# commands
110
111ifneq ($(filter 4.%,$(MAKE_VERSION)),) # make-4
112ifneq ($(filter %s ,$(firstword x$(MAKEFLAGS))),)
113 quiet=silent_
114endif
115else # make-3.8x
116ifneq ($(filter s% -s%,$(MAKEFLAGS)),)
117 quiet=silent_
118endif
119endif
120
121export quiet Q KBUILD_VERBOSE
122
123# kbuild supports saving output files in a separate directory.
124# To locate output files in a separate directory two syntaxes are supported.
125# In both cases the working directory must be the root of the kernel src.
126# 1) O=
127# Use "make O=dir/to/store/output/files/"
128#
129# 2) Set KBUILD_OUTPUT
130# Set the environment variable KBUILD_OUTPUT to point to the directory
131# where the output files shall be placed.
132# export KBUILD_OUTPUT=dir/to/store/output/files/
133# make
134#
135# The O= assignment takes precedence over the KBUILD_OUTPUT environment
136# variable.
137
138# KBUILD_SRC is set on invocation of make in OBJ directory
139# KBUILD_SRC is not intended to be used by the regular user (for now)
140ifeq ($(KBUILD_SRC),)
141
142# OK, Make called in directory where kernel src resides
143# Do we want to locate output files in a separate directory?
144ifeq ("$(origin O)", "command line")
145 KBUILD_OUTPUT := $(O)
146endif
147
148# That's our default target when none is given on the command line
149PHONY := _all
150_all:
151
152# Cancel implicit rules on top Makefile
153$(CURDIR)/Makefile Makefile: ;
154
155ifneq ($(KBUILD_OUTPUT),)
156# Invoke a second make in the output directory, passing relevant variables
157# check that the output directory actually exists
158saved-output := $(KBUILD_OUTPUT)
159KBUILD_OUTPUT := $(shell mkdir -p $(KBUILD_OUTPUT) && cd $(KBUILD_OUTPUT) \
160 && /bin/pwd)
161$(if $(KBUILD_OUTPUT),, \
162 $(error failed to create output directory "$(saved-output)"))
163
164# Look for make include files relative to root of kernel src
165#
166# This does not become effective immediately because MAKEFLAGS is re-parsed
167# once after the Makefile is read. It is OK since we are going to invoke
168# 'sub-make' below.
169MAKEFLAGS += --include-dir=$(CURDIR)
170
171PHONY += $(MAKECMDGOALS) sub-make
172
173$(filter-out _all sub-make $(CURDIR)/Makefile, $(MAKECMDGOALS)) _all: sub-make
174 @:
175
176sub-make: FORCE
177 $(Q)$(MAKE) -C $(KBUILD_OUTPUT) KBUILD_SRC=$(CURDIR) \
178 -f $(CURDIR)/Makefile $(filter-out _all sub-make,$(MAKECMDGOALS))
179
180# Leave processing to above invocation of make
181skip-makefile := 1
182endif # ifneq ($(KBUILD_OUTPUT),)
183endif # ifeq ($(KBUILD_SRC),)
184
185# We process the rest of the Makefile if this is the final invocation of make
186ifeq ($(skip-makefile),)
187
188# Do not print "Entering directory ...",
189# but we want to display it when entering to the output directory
190# so that IDEs/editors are able to understand relative filenames.
191MAKEFLAGS += --no-print-directory
192
193# Call a source code checker (by default, "sparse") as part of the
194# C compilation.
195#
196# Use 'make C=1' to enable checking of only re-compiled files.
197# Use 'make C=2' to enable checking of *all* source files, regardless
198# of whether they are re-compiled or not.
199#
200# See the file "doc/sparse.txt" for more details, including
201# where to get the "sparse" utility.
202
203ifeq ("$(origin C)", "command line")
204 KBUILD_CHECKSRC = $(C)
205endif
206ifndef KBUILD_CHECKSRC
207 KBUILD_CHECKSRC = 0
208endif
209
210# Use make M=dir to specify directory of external module to build
211# Old syntax make ... SUBDIRS=$PWD is still supported
212# Setting the environment variable KBUILD_EXTMOD take precedence
213ifdef SUBDIRS
214 KBUILD_EXTMOD ?= $(SUBDIRS)
215endif
216
217ifeq ("$(origin M)", "command line")
218 KBUILD_EXTMOD := $(M)
219endif
220
221# If building an external module we do not care about the all: rule
222# but instead _all depend on modules
223PHONY += all
224ifeq ($(KBUILD_EXTMOD),)
225_all: all
226else
227_all: modules
228endif
229
230ifeq ($(KBUILD_SRC),)
231 # building in the source tree
232 srctree := .
233else
234 ifeq ($(KBUILD_SRC)/,$(dir $(CURDIR)))
235 # building in a subdirectory of the source tree
236 srctree := ..
237 else
238 srctree := $(KBUILD_SRC)
239 endif
240endif
241objtree := .
242src := $(srctree)
243obj := $(objtree)
244
245VPATH := $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))
246
247export srctree objtree VPATH
248
249# Make sure CDPATH settings don't interfere
250unexport CDPATH
251
252#########################################################################
253
254HOSTARCH := $(shell uname -m | \
255 sed -e s/i.86/x86/ \
256 -e s/sun4u/sparc64/ \
257 -e s/arm.*/arm/ \
258 -e s/sa110/arm/ \
259 -e s/ppc64/powerpc/ \
260 -e s/ppc/powerpc/ \
261 -e s/macppc/powerpc/\
262 -e s/sh.*/sh/)
263
264HOSTOS := $(shell uname -s | tr '[:upper:]' '[:lower:]' | \
265 sed -e 's/\(cygwin\).*/cygwin/')
266
267export HOSTARCH HOSTOS
268
269#########################################################################
270
271# set default to nothing for native builds
272ifeq ($(HOSTARCH),$(ARCH))
273CROSS_COMPILE ?=
274endif
275
276KCONFIG_CONFIG ?= .config
277export KCONFIG_CONFIG
278
279# SHELL used by kbuild
280CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
281 else if [ -x /bin/bash ]; then echo /bin/bash; \
282 else echo sh; fi ; fi)
283
284HOST_LFS_CFLAGS := $(shell getconf LFS_CFLAGS 2>/dev/null)
285HOST_LFS_LDFLAGS := $(shell getconf LFS_LDFLAGS 2>/dev/null)
286HOST_LFS_LIBS := $(shell getconf LFS_LIBS 2>/dev/null)
287
288HOSTCC = cc
289HOSTCXX = c++
290KBUILD_HOSTCFLAGS := -Wall -Wstrict-prototypes -O2 -fomit-frame-pointer \
291 $(HOST_LFS_CFLAGS) $(HOSTCFLAGS)
292KBUILD_HOSTCXXFLAGS := -O2 $(HOST_LFS_CFLAGS) $(HOSTCXXFLAGS)
293KBUILD_HOSTLDFLAGS := $(HOST_LFS_LDFLAGS) $(HOSTLDFLAGS)
294KBUILD_HOSTLDLIBS := $(HOST_LFS_LIBS) $(HOSTLDLIBS)
295
296# With the move to GCC 6, we have implicitly upgraded our language
297# standard to GNU11 (see https://gcc.gnu.org/gcc-5/porting_to.html).
298# Some Linux distributions (including RHEL7, SLES13, Debian 8) still
299# have older compilers as their default, so we make it explicit for
300# these that our host tools are GNU11 (i.e. C11 w/ GNU extensions).
301CSTD_FLAG := -std=gnu11
302ifeq ($(HOSTOS),linux)
303KBUILD_HOSTCFLAGS += $(CSTD_FLAG)
304endif
305
306ifeq ($(HOSTOS),cygwin)
307KBUILD_HOSTCFLAGS += -ansi
308endif
309
310# Mac OS X / Darwin's C preprocessor is Apple specific. It
311# generates numerous errors and warnings. We want to bypass it
312# and use GNU C's cpp. To do this we pass the -traditional-cpp
313# option to the compiler. Note that the -traditional-cpp flag
314# DOES NOT have the same semantics as GNU C's flag, all it does
315# is invoke the GNU preprocessor in stock ANSI/ISO C fashion.
316#
317# Apple's linker is similar, thanks to the new 2 stage linking
318# multiple symbol definitions are treated as errors, hence the
319# -multiply_defined suppress option to turn off this error.
320#
321ifeq ($(HOSTOS),darwin)
322# get major and minor product version (e.g. '10' and '6' for Snow Leopard)
323DARWIN_MAJOR_VERSION = $(shell sw_vers -productVersion | cut -f 1 -d '.')
324DARWIN_MINOR_VERSION = $(shell sw_vers -productVersion | cut -f 2 -d '.')
325
326os_x_before = $(shell if [ $(DARWIN_MAJOR_VERSION) -le $(1) -a \
327 $(DARWIN_MINOR_VERSION) -le $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
328
329os_x_after = $(shell if [ $(DARWIN_MAJOR_VERSION) -ge $(1) -a \
330 $(DARWIN_MINOR_VERSION) -ge $(2) ] ; then echo "$(3)"; else echo "$(4)"; fi ;)
331
332# Snow Leopards build environment has no longer restrictions as described above
333HOSTCC = $(call os_x_before, 10, 5, "cc", "gcc")
334KBUILD_HOSTCFLAGS += $(call os_x_before, 10, 4, "-traditional-cpp")
335KBUILD_HOSTLDFLAGS += $(call os_x_before, 10, 5, "-multiply_defined suppress")
336
337# macOS Mojave (10.14.X)
338# Undefined symbols for architecture x86_64: "_PyArg_ParseTuple"
339KBUILD_HOSTLDFLAGS += $(call os_x_after, 10, 14, "-lpython -dynamclib", "")
340endif
341
342# Decide whether to build built-in, modular, or both.
343# Normally, just do built-in.
344
345KBUILD_MODULES :=
346KBUILD_BUILTIN := 1
347
348# If we have only "make modules", don't compile built-in objects.
349# When we're building modules with modversions, we need to consider
350# the built-in objects during the descend as well, in order to
351# make sure the checksums are up to date before we record them.
352
353ifeq ($(MAKECMDGOALS),modules)
354 KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
355endif
356
357# If we have "make <whatever> modules", compile modules
358# in addition to whatever we do anyway.
359# Just "make" or "make all" shall build modules as well
360
361# U-Boot does not need modules
362#ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
363# KBUILD_MODULES := 1
364#endif
365
366#ifeq ($(MAKECMDGOALS),)
367# KBUILD_MODULES := 1
368#endif
369
370# Check ths size of a binary:
371# Args:
372# $1: File to check
373# #2: Size limit in bytes (decimal or 0xhex)
374define size_check
375 actual=$$( wc -c $1 | awk '{print $$1}'); \
376 limit=$$( printf "%d" $2 ); \
377 if test $$actual -gt $$limit; then \
378 echo "$1 exceeds file size limit:" >&2; \
379 echo " limit: $$(printf %#x $$limit) bytes" >&2; \
380 echo " actual: $$(printf %#x $$actual) bytes" >&2; \
381 echo " excess: $$(printf %#x $$((actual - limit))) bytes" >&2;\
382 exit 1; \
383 fi
384endef
385export size_check
386
387export KBUILD_MODULES KBUILD_BUILTIN
388export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD
389
390# We need some generic definitions (do not try to remake the file).
391scripts/Kbuild.include: ;
392include scripts/Kbuild.include
393
394# Make variables (CC, etc...)
395
396AS = $(CROSS_COMPILE)as
397# Always use GNU ld
398ifneq ($(shell $(CROSS_COMPILE)ld.bfd -v 2> /dev/null),)
399LD = $(CROSS_COMPILE)ld.bfd
400else
401LD = $(CROSS_COMPILE)ld
402endif
403CC = $(CROSS_COMPILE)gcc
404CPP = $(CC) -E
405AR = $(CROSS_COMPILE)ar
406NM = $(CROSS_COMPILE)nm
407LDR = $(CROSS_COMPILE)ldr
408STRIP = $(CROSS_COMPILE)strip
409OBJCOPY = $(CROSS_COMPILE)objcopy
410OBJDUMP = $(CROSS_COMPILE)objdump
411LEX = flex
412YACC = bison
413AWK = awk
414PERL = perl
415PYTHON ?= python
416PYTHON2 = python2
417PYTHON3 ?= python3
418DTC ?= $(objtree)/scripts/dtc/dtc
419CHECK = sparse
420
421CHECKFLAGS := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ \
422 -Wbitwise -Wno-return-void -D__CHECK_ENDIAN__ $(CF)
423
424KBUILD_CPPFLAGS := -D__KERNEL__ -D__UBOOT__
425
426KBUILD_CFLAGS := -Wall -Wstrict-prototypes \
427 -Wno-format-security \
428 -fno-builtin -ffreestanding $(CSTD_FLAG)
429KBUILD_CFLAGS += -fshort-wchar -fno-strict-aliasing
430KBUILD_AFLAGS := -D__ASSEMBLY__
431KBUILD_LDFLAGS :=
432
433ifeq ($(cc-name),clang)
434ifneq ($(CROSS_COMPILE),)
435CLANG_TARGET := --target=$(notdir $(CROSS_COMPILE:%-=%))
436GCC_TOOLCHAIN_DIR := $(dir $(shell which $(LD)))
437CLANG_PREFIX := --prefix=$(GCC_TOOLCHAIN_DIR)
438GCC_TOOLCHAIN := $(realpath $(GCC_TOOLCHAIN_DIR)/..)
439endif
440ifneq ($(GCC_TOOLCHAIN),)
441CLANG_GCC_TC := --gcc-toolchain=$(GCC_TOOLCHAIN)
442endif
443KBUILD_CFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
444KBUILD_AFLAGS += $(CLANG_TARGET) $(CLANG_GCC_TC) $(CLANG_PREFIX)
445KBUILD_CFLAGS += $(call cc-option, -no-integrated-as)
446KBUILD_AFLAGS += $(call cc-option, -no-integrated-as)
447endif
448
449# Don't generate position independent code
450KBUILD_CFLAGS += $(call cc-option,-fno-PIE)
451KBUILD_AFLAGS += $(call cc-option,-fno-PIE)
452
453# Read UBOOTRELEASE from include/config/uboot.release (if it exists)
454UBOOTRELEASE = $(shell cat include/config/uboot.release 2> /dev/null)
455UBOOTVERSION = $(VERSION)$(if $(PATCHLEVEL),.$(PATCHLEVEL)$(if $(SUBLEVEL),.$(SUBLEVEL)))$(EXTRAVERSION)
456
457export VERSION PATCHLEVEL SUBLEVEL UBOOTRELEASE UBOOTVERSION
458export ARCH CPU BOARD VENDOR SOC CPUDIR BOARDDIR
459export CONFIG_SHELL HOSTCC KBUILD_HOSTCFLAGS CROSS_COMPILE AS LD CC
460export CPP AR NM LDR STRIP OBJCOPY OBJDUMP KBUILD_HOSTLDFLAGS KBUILD_HOSTLDLIBS
461export MAKE LEX YACC AWK PERL PYTHON PYTHON2 PYTHON3
462export HOSTCXX KBUILD_HOSTCXXFLAGS CHECK CHECKFLAGS DTC DTC_FLAGS
463
464export KBUILD_CPPFLAGS NOSTDINC_FLAGS UBOOTINCLUDE OBJCOPYFLAGS KBUILD_LDFLAGS
465export KBUILD_CFLAGS KBUILD_AFLAGS
466
467export CC_VERSION_TEXT := $(shell $(CC) --version | head -n 1)
468
469# When compiling out-of-tree modules, put MODVERDIR in the module
470# tree rather than in the kernel tree. The kernel tree might
471# even be read-only.
472export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions
473
474# Files to ignore in find ... statements
475
476export RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o \
477 -name CVS -o -name .pc -o -name .hg -o -name .git \) \
478 -prune -o
479export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn \
480 --exclude CVS --exclude .pc --exclude .hg --exclude .git
481
482# ===========================================================================
483# Rules shared between *config targets and build targets
484
485# Basic helpers built in scripts/
486PHONY += scripts_basic
487scripts_basic:
488 $(Q)$(MAKE) $(build)=scripts/basic
489 $(Q)rm -f .tmp_quiet_recordmcount
490
491# To avoid any implicit rule to kick in, define an empty command.
492scripts/basic/%: scripts_basic ;
493
494PHONY += outputmakefile
495# outputmakefile generates a Makefile in the output directory, if using a
496# separate output directory. This allows convenient use of make in the
497# output directory.
498outputmakefile:
499ifneq ($(KBUILD_SRC),)
500 $(Q)ln -fsn $(srctree) source
501 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/mkmakefile $(srctree)
502endif
503
504# To make sure we do not include .config for any of the *config targets
505# catch them early, and hand them over to scripts/kconfig/Makefile
506# It is allowed to specify more targets when calling make, including
507# mixing *config targets and build targets.
508# For example 'make oldconfig all'.
509# Detect when mixed targets is specified, and make a second invocation
510# of make so .config is not included in this case either (for *config).
511
512version_h := include/generated/version_autogenerated.h
513timestamp_h := include/generated/timestamp_autogenerated.h
514defaultenv_h := include/generated/defaultenv_autogenerated.h
515dt_h := include/generated/dt.h
516
517no-dot-config-targets := clean clobber mrproper distclean \
518 help %docs check% coccicheck \
519 ubootversion backup tests check qcheck tcheck
520
521config-targets := 0
522mixed-targets := 0
523dot-config := 1
524
525ifneq ($(filter $(no-dot-config-targets), $(MAKECMDGOALS)),)
526 ifeq ($(filter-out $(no-dot-config-targets), $(MAKECMDGOALS)),)
527 dot-config := 0
528 endif
529endif
530
531ifeq ($(KBUILD_EXTMOD),)
532 ifneq ($(filter config %config,$(MAKECMDGOALS)),)
533 config-targets := 1
534 ifneq ($(words $(MAKECMDGOALS)),1)
535 mixed-targets := 1
536 endif
537 endif
538endif
539
540ifeq ($(mixed-targets),1)
541# ===========================================================================
542# We're called with mixed targets (*config and build targets).
543# Handle them one by one.
544
545PHONY += $(MAKECMDGOALS) __build_one_by_one
546
547$(filter-out __build_one_by_one, $(MAKECMDGOALS)): __build_one_by_one
548 @:
549
550__build_one_by_one:
551 $(Q)set -e; \
552 for i in $(MAKECMDGOALS); do \
553 $(MAKE) -f $(srctree)/Makefile $$i; \
554 done
555
556else
557ifeq ($(config-targets),1)
558# ===========================================================================
559# *config targets only - make sure prerequisites are updated, and descend
560# in scripts/kconfig to make the *config target
561
562KBUILD_DEFCONFIG := sandbox_defconfig
563export KBUILD_DEFCONFIG KBUILD_KCONFIG
564
565config: scripts_basic outputmakefile FORCE
566 $(Q)$(MAKE) $(build)=scripts/kconfig $@
567
568%config: scripts_basic outputmakefile FORCE
569 $(Q)$(MAKE) $(build)=scripts/kconfig $@
570
571else
572# ===========================================================================
573# Build targets only - this includes vmlinux, arch specific targets, clean
574# targets and others. In general all targets except *config targets.
575
576# Additional helpers built in scripts/
577# Carefully list dependencies so we do not try to build scripts twice
578# in parallel
579PHONY += scripts
580scripts: scripts_basic scripts_dtc include/config/auto.conf
581 $(Q)$(MAKE) $(build)=$(@)
582
583ifeq ($(dot-config),1)
584# Read in config
585-include include/config/auto.conf
586
587# Read in dependencies to all Kconfig* files, make sure to run
588# oldconfig if changes are detected.
589-include include/config/auto.conf.cmd
590
591# To avoid any implicit rule to kick in, define an empty command
592$(KCONFIG_CONFIG) include/config/auto.conf.cmd: ;
593
594# If .config is newer than include/config/auto.conf, someone tinkered
595# with it and forgot to run make oldconfig.
596# if auto.conf.cmd is missing then we are probably in a cleaned tree so
597# we execute the config step to be sure to catch updated Kconfig files
598include/config/%.conf: $(KCONFIG_CONFIG) include/config/auto.conf.cmd
599 $(Q)$(MAKE) -f $(srctree)/Makefile syncconfig
600 @# If the following part fails, include/config/auto.conf should be
601 @# deleted so "make silentoldconfig" will be re-run on the next build.
602 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf || \
603 { rm -f include/config/auto.conf; false; }
604 @# include/config.h has been updated after "make silentoldconfig".
605 @# We need to touch include/config/auto.conf so it gets newer
606 @# than include/config.h.
607 @# Otherwise, 'make silentoldconfig' would be invoked twice.
608 $(Q)touch include/config/auto.conf
609
610u-boot.cfg spl/u-boot.cfg tpl/u-boot.cfg:
611 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.autoconf $(@)
612
613-include include/autoconf.mk
614-include include/autoconf.mk.dep
615
616# We want to include arch/$(ARCH)/config.mk only when include/config/auto.conf
617# is up-to-date. When we switch to a different board configuration, old CONFIG
618# macros are still remaining in include/config/auto.conf. Without the following
619# gimmick, wrong config.mk would be included leading nasty warnings/errors.
620ifneq ($(wildcard $(KCONFIG_CONFIG)),)
621ifneq ($(wildcard include/config/auto.conf),)
622autoconf_is_old := $(shell find . -path ./$(KCONFIG_CONFIG) -newer \
623 include/config/auto.conf)
624ifeq ($(autoconf_is_old),)
625include config.mk
626include arch/$(ARCH)/Makefile
627endif
628endif
629endif
630
631# These are set by the arch-specific config.mk. Make sure they are exported
632# so they can be used when building an EFI application.
633export EFI_LDS # Filename of EFI link script in arch/$(ARCH)/lib
634export EFI_CRT0 # Filename of EFI CRT0 in arch/$(ARCH)/lib
635export EFI_RELOC # Filename of EFU relocation code in arch/$(ARCH)/lib
636export CFLAGS_EFI # Compiler flags to add when building EFI app
637export CFLAGS_NON_EFI # Compiler flags to remove when building EFI app
638export EFI_TARGET # binutils target if EFI is natively supported
639
640# If board code explicitly specified LDSCRIPT or CONFIG_SYS_LDSCRIPT, use
641# that (or fail if absent). Otherwise, search for a linker script in a
642# standard location.
643
644ifndef LDSCRIPT
645 #LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds.debug
646 ifdef CONFIG_SYS_LDSCRIPT
647 # need to strip off double quotes
648 LDSCRIPT := $(srctree)/$(CONFIG_SYS_LDSCRIPT:"%"=%)
649 endif
650endif
651
652# If there is no specified link script, we look in a number of places for it
653ifndef LDSCRIPT
654 ifeq ($(wildcard $(LDSCRIPT)),)
655 LDSCRIPT := $(srctree)/board/$(BOARDDIR)/u-boot.lds
656 endif
657 ifeq ($(wildcard $(LDSCRIPT)),)
658 LDSCRIPT := $(srctree)/$(CPUDIR)/u-boot.lds
659 endif
660 ifeq ($(wildcard $(LDSCRIPT)),)
661 LDSCRIPT := $(srctree)/arch/$(ARCH)/cpu/u-boot.lds
662 endif
663endif
664
665else
666# Dummy target needed, because used as prerequisite
667include/config/auto.conf: ;
668endif # $(dot-config)
669
670#
671# Xtensa linker script cannot be preprocessed with -ansi because of
672# preprocessor operations on strings that don't make C identifiers.
673#
674ifeq ($(CONFIG_XTENSA),)
675LDPPFLAGS += -ansi
676endif
677
678ifdef CONFIG_CC_OPTIMIZE_FOR_SIZE
679KBUILD_CFLAGS += -Os
680else
681KBUILD_CFLAGS += -O2
682endif
683
684LTO_CFLAGS :=
685LTO_FINAL_LDFLAGS :=
686export LTO_CFLAGS LTO_FINAL_LDFLAGS
687ifdef CONFIG_LTO
688 ifeq ($(cc-name),clang)
689 LTO_CFLAGS += -flto
690 LTO_FINAL_LDFLAGS += -flto
691
692 AR = $(shell $(CC) -print-prog-name=llvm-ar)
693 NM = $(shell $(CC) -print-prog-name=llvm-nm)
694 else
695 NPROC := $(shell nproc 2>/dev/null || echo 1)
696 LTO_CFLAGS += -flto=$(NPROC)
697 LTO_FINAL_LDFLAGS += -fuse-linker-plugin -flto=$(NPROC)
698
699 # use plugin aware tools
700 AR = $(CROSS_COMPILE)gcc-ar
701 NM = $(CROSS_COMPILE)gcc-nm
702 endif
703
704 CFLAGS_NON_EFI += $(LTO_CFLAGS)
705
706 KBUILD_CFLAGS += $(LTO_CFLAGS)
707endif
708
709ifeq ($(CONFIG_STACKPROTECTOR),y)
710KBUILD_CFLAGS += $(call cc-option,-fstack-protector-strong)
711CFLAGS_EFI += $(call cc-option,-fno-stack-protector)
712else
713KBUILD_CFLAGS += $(call cc-option,-fno-stack-protector)
714endif
715KBUILD_CFLAGS += $(call cc-option,-fno-delete-null-pointer-checks)
716
717# disable pointer signed / unsigned warnings in gcc 4.0
718KBUILD_CFLAGS += -Wno-pointer-sign
719
720# disable stringop warnings in gcc 8+
721KBUILD_CFLAGS += $(call cc-disable-warning, stringop-truncation)
722
723KBUILD_CFLAGS += $(call cc-disable-warning, zero-length-bounds)
724KBUILD_CFLAGS += $(call cc-disable-warning, array-bounds)
725KBUILD_CFLAGS += $(call cc-disable-warning, stringop-overflow)
726
727# Enabled with W=2, disabled by default as noisy
728KBUILD_CFLAGS += $(call cc-disable-warning, maybe-uninitialized)
729
730# change __FILE__ to the relative path from the srctree
731KBUILD_CFLAGS += $(call cc-option,-fmacro-prefix-map=$(srctree)/=)
732
733KBUILD_CFLAGS += -g
734# $(KBUILD_AFLAGS) sets -g, which causes gcc to pass a suitable -g<format>
735# option to the assembler.
736KBUILD_AFLAGS += -g
737
738# Report stack usage if supported
739# ARC tools based on GCC 7.1 has an issue with stack usage
740# with naked functions, see commit message for more details
741ifndef CONFIG_ARC
742ifeq ($(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-stack-usage.sh $(CC)),y)
743 KBUILD_CFLAGS += -fstack-usage
744endif
745endif
746
747KBUILD_CFLAGS += $(call cc-option,-Wno-format-nonliteral)
748KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
749
750ifdef CONFIG_CC_IS_CLANG
751KBUILD_CPPFLAGS += $(call cc-option,-Qunused-arguments,)
752KBUILD_CFLAGS += $(call cc-disable-warning, format-invalid-specifier)
753KBUILD_CFLAGS += $(call cc-disable-warning, gnu)
754KBUILD_CFLAGS += $(call cc-disable-warning, address-of-packed-member)
755# Quiet clang warning: comparison of unsigned expression < 0 is always false
756KBUILD_CFLAGS += $(call cc-disable-warning, tautological-compare)
757# CLANG uses a _MergedGlobals as optimization, but this breaks modpost, as the
758# source of a reference will be _MergedGlobals and not on of the whitelisted names.
759# See modpost pattern 2
760KBUILD_CFLAGS += $(call cc-option, -mno-global-merge,)
761KBUILD_CFLAGS += $(call cc-option, -fcatch-undefined-behavior)
762endif
763
764# These warnings generated too much noise in a regular build.
765# Use make W=1 to enable them (see scripts/Makefile.extrawarn)
766KBUILD_CFLAGS += $(call cc-disable-warning, unused-but-set-variable)
767
768# Prohibit date/time macros, which would make the build non-deterministic
769KBUILD_CFLAGS += $(call cc-option,-Werror=date-time)
770
771include scripts/Makefile.extrawarn
772
773# Add user supplied CPPFLAGS, AFLAGS and CFLAGS as the last assignments
774KBUILD_CPPFLAGS += $(KCPPFLAGS)
775KBUILD_AFLAGS += $(KAFLAGS)
776KBUILD_CFLAGS += $(KCFLAGS)
777
778KBUILD_HOSTCFLAGS += $(if $(CONFIG_TOOLS_DEBUG),-g)
779
780# Use UBOOTINCLUDE when you must reference the include/ directory.
781# Needed to be compatible with the O= option
782UBOOTINCLUDE := \
783 -Iinclude \
784 $(if $(KBUILD_SRC), -I$(srctree)/include) \
785 $(if $(CONFIG_$(SPL_)SYS_THUMB_BUILD), \
786 $(if $(CONFIG_HAS_THUMB2), \
787 $(if $(CONFIG_CPU_V7M), \
788 -I$(srctree)/arch/arm/thumb1/include), \
789 -I$(srctree)/arch/arm/thumb1/include)) \
790 -I$(srctree)/arch/$(ARCH)/include \
791 -include $(srctree)/include/linux/kconfig.h
792
793NOSTDINC_FLAGS += -nostdinc -isystem $(shell $(CC) -print-file-name=include)
794
795# FIX ME
796cpp_flags := $(KBUILD_CPPFLAGS) $(PLATFORM_CPPFLAGS) $(UBOOTINCLUDE) \
797 $(NOSTDINC_FLAGS)
798c_flags := $(KBUILD_CFLAGS) $(cpp_flags)
799
800#########################################################################
801# U-Boot objects....order is important (i.e. start must be first)
802
803HAVE_VENDOR_COMMON_LIB = $(if $(wildcard $(srctree)/board/$(VENDOR)/common/Makefile),y,n)
804
805libs-$(CONFIG_API) += api/
806libs-$(HAVE_VENDOR_COMMON_LIB) += board/$(VENDOR)/common/
807libs-y += cmd/
808libs-y += common/
809libs-$(CONFIG_OF_EMBED) += dts/
810libs-y += env/
811libs-y += lib/
812libs-y += fs/
813libs-y += net/
814libs-y += disk/
815libs-y += drivers/
816libs-y += drivers/dma/
817libs-y += drivers/gpio/
818libs-y += drivers/net/
819libs-y += drivers/net/phy/
820libs-y += drivers/power/ \
821 drivers/power/domain/ \
822 drivers/power/fuel_gauge/ \
823 drivers/power/mfd/ \
824 drivers/power/pmic/ \
825 drivers/power/battery/ \
826 drivers/power/regulator/
827libs-y += drivers/spi/
828libs-$(CONFIG_FMAN_ENET) += drivers/net/fm/
829libs-$(CONFIG_SYS_FSL_DDR) += drivers/ddr/fsl/
830libs-$(CONFIG_SYS_FSL_MMDC) += drivers/ddr/fsl/
831libs-$(CONFIG_$(SPL_)ALTERA_SDRAM) += drivers/ddr/altera/
832libs-y += drivers/serial/
833libs-y += drivers/usb/cdns3/
834libs-y += drivers/usb/dwc3/
835libs-y += drivers/usb/common/
836libs-y += drivers/usb/emul/
837libs-y += drivers/usb/eth/
838libs-$(CONFIG_USB_DEVICE) += drivers/usb/gadget/
839libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/
840libs-$(CONFIG_USB_GADGET) += drivers/usb/gadget/udc/
841libs-y += drivers/usb/host/
842libs-y += drivers/usb/mtu3/
843libs-y += drivers/usb/musb/
844libs-y += drivers/usb/musb-new/
845libs-y += drivers/usb/phy/
846libs-y += drivers/usb/ulpi/
847ifdef CONFIG_POST
848libs-y += post/
849endif
850libs-$(CONFIG_UNIT_TEST) += test/
851libs-$(CONFIG_UT_ENV) += test/env/
852libs-$(CONFIG_UT_OPTEE) += test/optee/
853libs-$(CONFIG_UT_OVERLAY) += test/overlay/
854
855libs-y += $(if $(BOARDDIR),board/$(BOARDDIR)/)
856
857libs-y := $(sort $(libs-y))
858
859u-boot-dirs := $(patsubst %/,%,$(filter %/, $(libs-y))) tools examples
860
861u-boot-alldirs := $(sort $(u-boot-dirs) $(patsubst %/,%,$(filter %/, $(libs-))))
862
863libs-y := $(patsubst %/, %/built-in.o, $(libs-y))
864
865u-boot-init := $(head-y)
866u-boot-main := $(libs-y)
867
868
869# Add GCC lib
870ifeq ($(CONFIG_USE_PRIVATE_LIBGCC),y)
871PLATFORM_LIBGCC = arch/$(ARCH)/lib/lib.a
872else
873PLATFORM_LIBGCC := -L $(shell dirname `$(CC) $(c_flags) -print-libgcc-file-name`) -lgcc
874endif
875PLATFORM_LIBS += $(PLATFORM_LIBGCC)
876
877ifdef CONFIG_CC_COVERAGE
878KBUILD_CFLAGS += --coverage
879PLATFORM_LIBGCC += -lgcov
880endif
881
882export PLATFORM_LIBS
883export PLATFORM_LIBGCC
884
885# Special flags for CPP when processing the linker script.
886# Pass the version down so we can handle backwards compatibility
887# on the fly.
888LDPPFLAGS += \
889 -include $(srctree)/include/u-boot/u-boot.lds.h \
890 -DCPUDIR=$(CPUDIR) \
891 $(shell $(LD) --version | \
892 sed -ne 's/GNU ld version \([0-9][0-9]*\)\.\([0-9][0-9]*\).*/-DLD_MAJOR=\1 -DLD_MINOR=\2/p')
893
894#########################################################################
895#########################################################################
896
897ifneq ($(CONFIG_BOARD_SIZE_LIMIT),)
898BOARD_SIZE_CHECK= @ $(call size_check,$@,$(CONFIG_BOARD_SIZE_LIMIT))
899else
900BOARD_SIZE_CHECK =
901endif
902
903ifneq ($(CONFIG_SPL_SIZE_LIMIT),0x0)
904SPL_SIZE_CHECK = @$(call size_check,$@,$$(tools/spl_size_limit))
905else
906SPL_SIZE_CHECK =
907endif
908
909ifneq ($(CONFIG_TPL_SIZE_LIMIT),0x0)
910TPL_SIZE_CHECK = @$(call size_check,$@,$(CONFIG_TPL_SIZE_LIMIT))
911else
912TPL_SIZE_CHECK =
913endif
914
915# Statically apply RELA-style relocations (currently arm64 only)
916# This is useful for arm64 where static relocation needs to be performed on
917# the raw binary, but certain simulators only accept an ELF file (but don't
918# do the relocation).
919ifneq ($(CONFIG_STATIC_RELA),)
920# $(1) is u-boot ELF, $(2) is u-boot bin, $(3) is text base
921quiet_cmd_static_rela = RELOC $@
922cmd_static_rela = \
923 start=$$($(NM) $(2) | grep __rel_dyn_start | cut -f 1 -d ' '); \
924 end=$$($(NM) $(2) | grep __rel_dyn_end | cut -f 1 -d ' '); \
925 tools/relocate-rela $(3) $(4) $$start $$end
926else
927quiet_cmd_static_rela =
928cmd_static_rela =
929endif
930
931# Always append INPUTS so that arch config.mk's can add custom ones
932INPUTS-y += u-boot.srec u-boot.bin u-boot.sym System.map binary_size_check
933
934INPUTS-$(CONFIG_ONENAND_U_BOOT) += u-boot-onenand.bin
935ifeq ($(CONFIG_SPL_FSL_PBL),y)
936INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot-with-spl-pbl.bin
937else
938ifneq ($(CONFIG_NXP_ESBC), y)
939# For Secure Boot The Image needs to be signed and Header must also
940# be included. So The image has to be built explicitly
941INPUTS-$(CONFIG_RAMBOOT_PBL) += u-boot.pbl
942endif
943endif
944INPUTS-$(CONFIG_SPL) += spl/u-boot-spl.bin
945ifeq ($(CONFIG_MX6)$(CONFIG_IMX_HAB), yy)
946INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
947else
948ifeq ($(CONFIG_MX7)$(CONFIG_IMX_HAB), yy)
949INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot-ivt.img
950else
951INPUTS-$(CONFIG_SPL_FRAMEWORK) += u-boot.img
952endif
953endif
954INPUTS-$(CONFIG_TPL) += tpl/u-boot-tpl.bin
955INPUTS-$(CONFIG_OF_SEPARATE) += u-boot.dtb
956INPUTS-$(CONFIG_BINMAN_STANDALONE_FDT) += u-boot.dtb
957ifeq ($(CONFIG_SPL_FRAMEWORK),y)
958INPUTS-$(CONFIG_OF_SEPARATE) += u-boot-dtb.img
959endif
960INPUTS-$(CONFIG_OF_HOSTFILE) += u-boot.dtb
961ifneq ($(CONFIG_SPL_TARGET),)
962INPUTS-$(CONFIG_SPL) += $(CONFIG_SPL_TARGET:"%"=%)
963endif
964INPUTS-$(CONFIG_REMAKE_ELF) += u-boot.elf
965INPUTS-$(CONFIG_EFI_APP) += u-boot-app.efi
966INPUTS-$(CONFIG_EFI_STUB) += u-boot-payload.efi
967
968# Generate this input file for binman
969ifeq ($(CONFIG_SPL),)
970INPUTS-$(CONFIG_ARCH_MEDIATEK) += u-boot-mtk.bin
971endif
972
973# Add optional build target if defined in board/cpu/soc headers
974ifneq ($(CONFIG_BUILD_TARGET),)
975INPUTS-y += $(CONFIG_BUILD_TARGET:"%"=%)
976endif
977
978ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
979INPUTS-y += init_sp_bss_offset_check
980endif
981
982ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
983INPUTS-y += u-boot-with-dtb.bin
984endif
985
986ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
987# On ARM64 this target is produced by binman so we don't need this dep
988ifeq ($(CONFIG_ARM64),y)
989ifeq ($(CONFIG_SPL),y)
990# TODO: Get binman to generate this too
991INPUTS-y += u-boot-rockchip.bin
992endif
993else
994ifeq ($(CONFIG_SPL),y)
995# Generate these inputs for binman which will create the output files
996INPUTS-y += idbloader.img u-boot.img
997endif
998endif
999endif
1000
1001INPUTS-$(CONFIG_X86) += u-boot-x86-start16.bin u-boot-x86-reset16.bin \
1002 $(if $(CONFIG_SPL_X86_16BIT_INIT),spl/u-boot-spl.bin) \
1003 $(if $(CONFIG_TPL_X86_16BIT_INIT),tpl/u-boot-tpl.bin)
1004
1005LDFLAGS_u-boot += $(LDFLAGS_FINAL)
1006
1007# Avoid 'Not enough room for program headers' error on binutils 2.28 onwards.
1008LDFLAGS_u-boot += $(call ld-option, --no-dynamic-linker)
1009
1010LDFLAGS_u-boot += --build-id=none
1011
1012ifeq ($(CONFIG_ARC)$(CONFIG_NIOS2)$(CONFIG_X86)$(CONFIG_XTENSA),)
1013LDFLAGS_u-boot += -Ttext $(CONFIG_SYS_TEXT_BASE)
1014endif
1015
1016# insure the checker run with the right endianness
1017CHECKFLAGS += $(if $(CONFIG_CPU_BIG_ENDIAN),-mbig-endian,-mlittle-endian)
1018
1019# the checker needs the correct machine size
1020CHECKFLAGS += $(if $(CONFIG_64BIT),-m64,-m32)
1021
1022# Normally we fill empty space with 0xff
1023quiet_cmd_objcopy = OBJCOPY $@
1024cmd_objcopy = $(OBJCOPY) --gap-fill=0xff $(OBJCOPYFLAGS) \
1025 $(OBJCOPYFLAGS_$(@F)) $< $@
1026
1027# Provide a version which does not do this, for use by EFI
1028quiet_cmd_zobjcopy = OBJCOPY $@
1029cmd_zobjcopy = $(OBJCOPY) $(OBJCOPYFLAGS) $(OBJCOPYFLAGS_$(@F)) $< $@
1030
1031quiet_cmd_efipayload = OBJCOPY $@
1032cmd_efipayload = $(OBJCOPY) -I binary -O $(EFIPAYLOAD_BFDTARGET) -B $(EFIPAYLOAD_BFDARCH) $< $@
1033
1034MKIMAGEOUTPUT ?= /dev/null
1035
1036quiet_cmd_mkimage = MKIMAGE $@
1037cmd_mkimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) -d $< $@ \
1038 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1039
1040quiet_cmd_mkfitimage = MKIMAGE $@
1041cmd_mkfitimage = $(objtree)/tools/mkimage $(MKIMAGEFLAGS_$(@F)) \
1042 -f $(U_BOOT_ITS) -p $(CONFIG_FIT_EXTERNAL_OFFSET) $@ \
1043 >$(MKIMAGEOUTPUT) $(if $(KBUILD_VERBOSE:0=), && cat $(MKIMAGEOUTPUT))
1044
1045quiet_cmd_cat = CAT $@
1046cmd_cat = cat $(filter-out $(PHONY), $^) > $@
1047
1048append = cat $(filter-out $< $(PHONY), $^) >> $@
1049
1050quiet_cmd_pad_cat = CAT $@
1051cmd_pad_cat = $(cmd_objcopy) && $(append) || { rm -f $@; false; }
1052
1053quiet_cmd_lzma = LZMA $@
1054cmd_lzma = lzma -c -z -k -9 $< > $@
1055
1056cfg: u-boot.cfg
1057
1058quiet_cmd_cfgcheck = CFGCHK $2
1059cmd_cfgcheck = $(srctree)/scripts/check-config.sh $2 \
1060 $(srctree)/scripts/config_whitelist.txt $(srctree)
1061
1062# Concat the value of all the CONFIGs (result is 'y' or 'yy', etc. )
1063got = $(foreach cfg,$(1),$($(cfg)))
1064
1065# expected value 'y for each one
1066expect = $(foreach cfg,$(1),y)
1067
1068# Show a deprecation message
1069# Args:
1070# 1: List of CONFIG_DM_... to migrate to (e.g. "CONFIG_DM_MMC CONFIG_BLK")
1071# 2: Name of component (e.g . "Ethernet drivers")
1072# 3: Release deadline (e.g. "v202.07")
1073# 4: Condition to require before checking (e.g. "$(CONFIG_NET)")
1074# Note: Script avoids bash construct, hence the strange double 'if'
1075# (patches welcome!)
1076define deprecated
1077 @if [ -n "$(strip $(4))" ]; then if [ "$(got)" != "$(expect)" ]; then \
1078 echo >&2 "===================== WARNING ======================"; \
1079 echo >&2 "This board does not use $(firstword $(1)) (Driver Model"; \
1080 echo >&2 "for $(2)). Please update the board to use"; \
1081 echo >&2 "$(firstword $(1)) before the $(3) release. Failure to"; \
1082 echo >&2 "update by the deadline may result in board removal."; \
1083 echo >&2 "See doc/driver-model/migration.rst for more info."; \
1084 echo >&2 "===================================================="; \
1085 fi; fi
1086
1087endef
1088
1089PHONY += inputs
1090inputs: $(INPUTS-y)
1091
1092all: .binman_stamp inputs
1093ifeq ($(CONFIG_BINMAN),y)
1094 $(call if_changed,binman)
1095endif
1096
1097# Timestamp file to make sure that binman always runs
1098.binman_stamp: FORCE
1099 @touch $@
1100
1101ifeq ($(CONFIG_DEPRECATED),y)
1102 $(warning "You have deprecated configuration options enabled in your .config! Please check your configuration.")
1103endif
1104ifeq ($(CONFIG_OF_EMBED),y)
1105 @echo >&2 "===================== WARNING ======================"
1106 @echo >&2 "CONFIG_OF_EMBED is enabled. This option should only"
1107 @echo >&2 "be used for debugging purposes. Please use"
1108 @echo >&2 "CONFIG_OF_SEPARATE for boards in mainline."
1109 @echo >&2 "See doc/README.fdt-control for more info."
1110 @echo >&2 "===================================================="
1111endif
1112ifneq ($(CONFIG_SPL_FIT_GENERATOR),)
1113 @echo >&2 "===================== WARNING ======================"
1114 @echo >&2 "This board uses CONFIG_SPL_FIT_GENERATOR. Please migrate"
1115 @echo >&2 "to binman instead, to avoid the proliferation of"
1116 @echo >&2 "arch-specific scripts with no tests."
1117 @echo >&2 "===================================================="
1118endif
1119ifneq ($(CONFIG_DM),y)
1120 @echo >&2 "===================== WARNING ======================"
1121 @echo >&2 "This board does not use CONFIG_DM. CONFIG_DM will be"
1122 @echo >&2 "compulsory starting with the v2020.01 release."
1123 @echo >&2 "Failure to update may result in board removal."
1124 @echo >&2 "See doc/driver-model/migration.rst for more info."
1125 @echo >&2 "===================================================="
1126endif
1127 $(call deprecated,CONFIG_WDT,DM watchdog,v2019.10,\
1128 $(CONFIG_WATCHDOG)$(CONFIG_HW_WATCHDOG))
1129 $(call deprecated,CONFIG_DM_ETH,Ethernet drivers,v2020.07,$(CONFIG_NET))
1130 $(call deprecated,CONFIG_DM_I2C,I2C drivers,v2022.04,$(CONFIG_SYS_I2C_LEGACY))
1131 @# Check that this build does not use CONFIG options that we do not
1132 @# know about unless they are in Kconfig. All the existing CONFIG
1133 @# options are whitelisted, so new ones should not be added.
1134 $(call cmd,cfgcheck,u-boot.cfg)
1135
1136PHONY += dtbs
1137dtbs: dts/dt.dtb
1138 @:
1139dts/dt.dtb: u-boot
1140 $(Q)$(MAKE) $(build)=dts dtbs
1141
1142quiet_cmd_copy = COPY $@
1143 cmd_copy = cp $< $@
1144
1145ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1146
1147ifeq ($(CONFIG_MULTI_DTB_FIT_LZO),y)
1148FINAL_DTB_CONTAINER = fit-dtb.blob.lzo
1149else ifeq ($(CONFIG_MULTI_DTB_FIT_GZIP),y)
1150FINAL_DTB_CONTAINER = fit-dtb.blob.gz
1151else
1152FINAL_DTB_CONTAINER = fit-dtb.blob
1153endif
1154
1155fit-dtb.blob.gz: fit-dtb.blob
1156 @gzip -kf9 $< > $@
1157
1158fit-dtb.blob.lzo: fit-dtb.blob
1159 @lzop -f9 $< > $@
1160
1161fit-dtb.blob: dts/dt.dtb FORCE
1162 $(call if_changed,mkimage)
1163ifneq ($(SOURCE_DATE_EPOCH),)
1164 touch -d @$(SOURCE_DATE_EPOCH) fit-dtb.blob
1165 chmod 0600 fit-dtb.blob
1166endif
1167
1168MKIMAGEFLAGS_fit-dtb.blob = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1169 -a 0 -e 0 -E \
1170 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) -d /dev/null
1171
1172ifneq ($(EXT_DTB),)
1173u-boot-fit-dtb.bin: u-boot-nodtb.bin $(EXT_DTB)
1174 $(call if_changed,cat)
1175else
1176u-boot-fit-dtb.bin: u-boot-nodtb.bin $(FINAL_DTB_CONTAINER)
1177 $(call if_changed,cat)
1178endif
1179
1180u-boot.bin: u-boot-fit-dtb.bin FORCE
1181 $(call if_changed,copy)
1182
1183u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1184 $(call if_changed,cat)
1185
1186else ifeq ($(CONFIG_OF_SEPARATE),y)
1187u-boot-dtb.bin: u-boot-nodtb.bin dts/dt.dtb FORCE
1188 $(call if_changed,cat)
1189
1190u-boot.bin: u-boot-dtb.bin FORCE
1191 $(call if_changed,copy)
1192else
1193u-boot.bin: u-boot-nodtb.bin FORCE
1194 $(call if_changed,copy)
1195endif
1196
1197# we call Makefile in arch/arm/mach-imx which
1198# has targets which are dependent on targets defined
1199# here. make could not resolve them and we must ensure
1200# that they are finished before calling imx targets
1201ifeq ($(CONFIG_MULTI_DTB_FIT),y)
1202IMX_DEPS = u-boot-fit-dtb.bin
1203endif
1204
1205%.imx: $(IMX_DEPS) %.bin
1206 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1207 $(BOARD_SIZE_CHECK)
1208
1209%.vyb: %.imx
1210 $(Q)$(MAKE) $(build)=arch/arm/cpu/armv7/vf610 $@
1211
1212quiet_cmd_copy = COPY $@
1213 cmd_copy = cp $< $@
1214
1215u-boot.dtb: dts/dt.dtb
1216 $(call cmd,copy)
1217
1218OBJCOPYFLAGS_u-boot.hex := -O ihex
1219
1220OBJCOPYFLAGS_u-boot.srec := -O srec
1221
1222u-boot.hex u-boot.srec: u-boot FORCE
1223 $(call if_changed,objcopy)
1224
1225OBJCOPYFLAGS_u-boot-elf.srec := $(OBJCOPYFLAGS_u-boot.srec)
1226
1227u-boot-elf.srec: u-boot.elf FORCE
1228 $(call if_changed,objcopy)
1229
1230OBJCOPYFLAGS_u-boot-spl.srec = $(OBJCOPYFLAGS_u-boot.srec)
1231
1232spl/u-boot-spl.srec: spl/u-boot-spl FORCE
1233 $(call if_changed,objcopy)
1234
1235%.scif: %.srec
1236 $(Q)$(MAKE) $(build)=arch/arm/mach-rmobile $@
1237
1238OBJCOPYFLAGS_u-boot-nodtb.bin := -O binary \
1239 $(if $(CONFIG_X86_16BIT_INIT),-R .start16 -R .resetvec) \
1240 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR),-R .bootpg -R .resetvec)
1241
1242binary_size_check: u-boot-nodtb.bin FORCE
1243 @file_size=$(shell wc -c u-boot-nodtb.bin | awk '{print $$1}') ; \
1244 map_size=$(shell cat u-boot.map | \
1245 awk '/_image_copy_start/ {start = $$1} /_image_binary_end/ {end = $$1} END {if (start != "" && end != "") print "ibase=16; " toupper(end) " - " toupper(start)}' \
1246 | sed 's/0X//g' \
1247 | bc); \
1248 if [ "" != "$$map_size" ]; then \
1249 if test $$map_size -ne $$file_size; then \
1250 echo "u-boot.map shows a binary size of $$map_size" >&2 ; \
1251 echo " but u-boot-nodtb.bin shows $$file_size" >&2 ; \
1252 exit 1; \
1253 fi \
1254 fi
1255
1256ifeq ($(CONFIG_INIT_SP_RELATIVE)$(CONFIG_OF_SEPARATE),yy)
1257ifneq ($(CONFIG_SYS_MALLOC_F_LEN),)
1258subtract_sys_malloc_f_len = space=$$(($${space} - $(CONFIG_SYS_MALLOC_F_LEN)))
1259else
1260subtract_sys_malloc_f_len = true
1261endif
1262# The 1/4 margin below is somewhat arbitrary. The likely initial SP usage is
1263# so low that the DTB could probably use 90%+ of the available space, for
1264# current values of CONFIG_SYS_INIT_SP_BSS_OFFSET at least. However, let's be
1265# safe for now and tweak this later if space becomes tight.
1266# A rejected alternative would be to check that some absolute minimum stack
1267# space was available. However, since CONFIG_SYS_INIT_SP_BSS_OFFSET is
1268# deliberately build-specific, to take account of build-to-build stack usage
1269# differences due to different feature sets, there is no common absolute value
1270# to check against.
1271init_sp_bss_offset_check: u-boot.dtb FORCE
1272 @dtb_size=$(shell wc -c u-boot.dtb | awk '{print $$1}') ; \
1273 space=$(CONFIG_SYS_INIT_SP_BSS_OFFSET) ; \
1274 $(subtract_sys_malloc_f_len) ; \
1275 quarter_space=$$(($${space} / 4)) ; \
1276 if [ $${dtb_size} -gt $${quarter_space} ]; then \
1277 echo "u-boot.dtb is larger than 1 quarter of " >&2 ; \
1278 echo "(CONFIG_SYS_INIT_SP_BSS_OFFSET - CONFIG_SYS_MALLOC_F_LEN)" >&2 ; \
1279 exit 1 ; \
1280 fi
1281endif
1282
1283shell_cmd = { $(call echo-cmd,$(1)) $(cmd_$(1)); }
1284
1285quiet_cmd_objcopy_uboot = OBJCOPY $@
1286ifdef cmd_static_rela
1287cmd_objcopy_uboot = $(cmd_objcopy) && $(call shell_cmd,static_rela,$<,$@,$(CONFIG_SYS_TEXT_BASE)) || { rm -f $@; false; }
1288else
1289cmd_objcopy_uboot = $(cmd_objcopy)
1290endif
1291
1292u-boot-nodtb.bin: u-boot FORCE
1293 $(call if_changed,objcopy_uboot)
1294 $(BOARD_SIZE_CHECK)
1295
1296u-boot.ldr: u-boot
1297 $(CREATE_LDR_ENV)
1298 $(LDR) -T $(CONFIG_CPU) -c $@ $< $(LDR_FLAGS)
1299 $(BOARD_SIZE_CHECK)
1300
1301# binman
1302# ---------------------------------------------------------------------------
1303# Use 'make BINMAN_DEBUG=1' to enable debugging
1304# Use 'make BINMAN_VERBOSE=3' to set vebosity level
1305default_dt := $(if $(DEVICE_TREE),$(DEVICE_TREE),$(CONFIG_DEFAULT_DEVICE_TREE))
1306
1307# Tell binman whether we have a devicetree for SPL and TPL
1308have_spl_dt := $(if $(CONFIG_SPL_OF_PLATDATA),,$(CONFIG_SPL_OF_CONTROL))
1309have_tpl_dt := $(if $(CONFIG_TPL_OF_PLATDATA),,$(CONFIG_TPL_OF_CONTROL))
1310
1311quiet_cmd_binman = BINMAN $@
1312cmd_binman = $(srctree)/tools/binman/binman $(if $(BINMAN_DEBUG),-D) \
1313 --toolpath $(objtree)/tools \
1314 $(if $(BINMAN_VERBOSE),-v$(BINMAN_VERBOSE)) \
1315 build -u -d u-boot.dtb -O . -m --allow-missing \
1316 -I . -I $(srctree) -I $(srctree)/board/$(BOARDDIR) \
1317 -I arch/$(ARCH)/dts -a of-list=$(CONFIG_OF_LIST) \
1318 -a atf-bl31-path=${BL31} \
1319 -a opensbi-path=${OPENSBI} \
1320 -a default-dt=$(default_dt) \
1321 -a scp-path=$(SCP) \
1322 -a spl-bss-pad=$(if $(CONFIG_SPL_SEPARATE_BSS),,1) \
1323 -a tpl-bss-pad=$(if $(CONFIG_TPL_SEPARATE_BSS),,1) \
1324 -a spl-dtb=$(have_spl_dt) -a tpl-dtb=$(have_tpl_dt) \
1325 $(BINMAN_$(@F))
1326
1327OBJCOPYFLAGS_u-boot.ldr.hex := -I binary -O ihex
1328
1329OBJCOPYFLAGS_u-boot.ldr.srec := -I binary -O srec
1330
1331u-boot.ldr.hex u-boot.ldr.srec: u-boot.ldr FORCE
1332 $(call if_changed,objcopy)
1333
1334#
1335# U-Boot entry point, needed for booting of full-blown U-Boot
1336# from the SPL U-Boot version.
1337#
1338ifndef CONFIG_SYS_UBOOT_START
1339CONFIG_SYS_UBOOT_START := $(CONFIG_SYS_TEXT_BASE)
1340endif
1341
1342# Boards with more complex image requirements can provide an .its source file
1343# or a generator script
1344# NOTE: Please do not use this. We are migrating away from Makefile rules to use
1345# binman instead.
1346ifneq ($(CONFIG_SPL_FIT_SOURCE),"")
1347U_BOOT_ITS := u-boot.its
1348$(U_BOOT_ITS): $(subst ",,$(CONFIG_SPL_FIT_SOURCE))
1349 $(call if_changed,copy)
1350else
1351ifneq ($(CONFIG_USE_SPL_FIT_GENERATOR),)
1352U_BOOT_ITS := u-boot.its
1353ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-imx/mkimage_fit_atf.sh")
1354U_BOOT_ITS_DEPS += u-boot-nodtb.bin
1355endif
1356ifeq ($(CONFIG_SPL_FIT_GENERATOR),"arch/arm/mach-rockchip/make_fit_atf.py")
1357U_BOOT_ITS_DEPS += u-boot
1358endif
1359$(U_BOOT_ITS): $(U_BOOT_ITS_DEPS) FORCE
1360 $(srctree)/$(CONFIG_SPL_FIT_GENERATOR) \
1361 $(patsubst %,arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) > $@
1362endif
1363endif
1364
1365ifdef CONFIG_SPL_LOAD_FIT
1366MKIMAGEFLAGS_u-boot.img = -f auto -A $(ARCH) -T firmware -C none -O u-boot \
1367 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1368 -p $(CONFIG_FIT_EXTERNAL_OFFSET) \
1369 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board" -E \
1370 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(DEVICE_TREE))) \
1371 $(patsubst %,-b arch/$(ARCH)/dts/%.dtb,$(subst ",,$(CONFIG_OF_LIST))) \
1372 $(patsubst %,-b arch/$(ARCH)/dts/%.dtbo,$(subst ",,$(CONFIG_OF_OVERLAY_LIST)))
1373else
1374MKIMAGEFLAGS_u-boot.img = -A $(ARCH) -T firmware -C none -O u-boot \
1375 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1376 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1377MKIMAGEFLAGS_u-boot-ivt.img = -A $(ARCH) -T firmware_ivt -C none -O u-boot \
1378 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1379 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1380u-boot-ivt.img: MKIMAGEOUTPUT = u-boot-ivt.img.log
1381endif
1382
1383MKIMAGEFLAGS_u-boot-dtb.img = $(MKIMAGEFLAGS_u-boot.img)
1384
1385# Some boards have the kwbimage.cfg file written in advance, while some
1386# other boards generate it on the fly during the build in the build tree.
1387# Let's check if the file exists in the build tree first, otherwise we
1388# fall back to use the one in the source tree.
1389KWD_CONFIG_FILE = $(shell \
1390 if [ -f $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%) ]; then \
1391 echo -n $(objtree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1392 else \
1393 echo -n $(srctree)/$(CONFIG_SYS_KWD_CONFIG:"%"=%); \
1394 fi)
1395
1396MKIMAGEFLAGS_u-boot.kwb = -n $(KWD_CONFIG_FILE) \
1397 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE)
1398
1399MKIMAGEFLAGS_u-boot-spl.kwb = -n $(KWD_CONFIG_FILE) \
1400 -T kwbimage -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1401 $(if $(KEYDIR),-k $(KEYDIR))
1402
1403MKIMAGEFLAGS_u-boot.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1404 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage
1405
1406ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1407UBOOT_BIN := u-boot-with-dtb.bin
1408else
1409UBOOT_BIN := u-boot.bin
1410endif
1411
1412MKIMAGEFLAGS_u-boot-lzma.img = -A $(ARCH) -T standalone -C lzma -O u-boot \
1413 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_UBOOT_START) \
1414 -n "U-Boot $(UBOOTRELEASE) for $(BOARD) board"
1415
1416u-boot.bin.lzma: u-boot.bin FORCE
1417 $(call if_changed,lzma)
1418
1419u-boot-lzma.img: u-boot.bin.lzma FORCE
1420 $(call if_changed,mkimage)
1421
1422u-boot-dtb.img u-boot.img u-boot.kwb u-boot.pbl u-boot-ivt.img: \
1423 $(if $(CONFIG_SPL_LOAD_FIT),u-boot-nodtb.bin \
1424 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE)$(CONFIG_BINMAN_STANDALONE_FDT),dts/dt.dtb) \
1425 ,$(UBOOT_BIN)) FORCE
1426 $(call if_changed,mkimage)
1427 $(BOARD_SIZE_CHECK)
1428
1429ifeq ($(CONFIG_SPL_LOAD_FIT_FULL),y)
1430MKIMAGEFLAGS_u-boot.itb =
1431else
1432MKIMAGEFLAGS_u-boot.itb = -E
1433endif
1434
1435ifdef U_BOOT_ITS
1436u-boot.itb: u-boot-nodtb.bin \
1437 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_OF_HOSTFILE),dts/dt.dtb) \
1438 $(U_BOOT_ITS) FORCE
1439 $(call if_changed,mkfitimage)
1440 $(BOARD_SIZE_CHECK)
1441endif
1442
1443u-boot-spl.kwb: u-boot.bin spl/u-boot-spl.bin FORCE
1444 $(call if_changed,mkimage)
1445
1446u-boot.sha1: u-boot.bin
1447 tools/ubsha1 u-boot.bin
1448
1449u-boot.dis: u-boot
1450 $(OBJDUMP) -d $< > $@
1451
1452ifneq ($(CONFIG_SPL_PAYLOAD),)
1453SPL_PAYLOAD := $(CONFIG_SPL_PAYLOAD:"%"=%)
1454else
1455SPL_PAYLOAD := u-boot.bin
1456endif
1457
1458SPL_IMAGE := $(CONFIG_SPL_IMAGE:"%"=%)
1459
1460OBJCOPYFLAGS_u-boot-with-spl.bin = -I binary -O binary \
1461 --pad-to=$(CONFIG_SPL_PAD_TO)
1462u-boot-with-spl.bin: $(SPL_IMAGE) $(SPL_PAYLOAD) FORCE
1463 $(call if_changed,pad_cat)
1464
1465ifeq ($(CONFIG_ARCH_ROCKCHIP),y)
1466
1467# TPL + SPL
1468ifeq ($(CONFIG_SPL)$(CONFIG_TPL),yy)
1469MKIMAGEFLAGS_u-boot-tpl-rockchip.bin = -n $(CONFIG_SYS_SOC) -T rksd
1470tpl/u-boot-tpl-rockchip.bin: tpl/u-boot-tpl.bin FORCE
1471 $(call if_changed,mkimage)
1472idbloader.img: tpl/u-boot-tpl-rockchip.bin spl/u-boot-spl.bin FORCE
1473 $(call if_changed,cat)
1474else
1475MKIMAGEFLAGS_idbloader.img = -n $(CONFIG_SYS_SOC) -T rksd
1476idbloader.img: spl/u-boot-spl.bin FORCE
1477 $(call if_changed,mkimage)
1478endif
1479
1480ifeq ($(CONFIG_ARM64),y)
1481OBJCOPYFLAGS_u-boot-rockchip.bin = -I binary -O binary \
1482 --pad-to=$(CONFIG_SPL_PAD_TO) --gap-fill=0xff
1483u-boot-rockchip.bin: idbloader.img u-boot.itb FORCE
1484 $(call if_changed,pad_cat)
1485endif # CONFIG_ARM64
1486
1487endif # CONFIG_ARCH_ROCKCHIP
1488
1489ifeq ($(CONFIG_ARCH_LPC32XX)$(CONFIG_SPL),yy)
1490MKIMAGEFLAGS_lpc32xx-spl.img = -T lpc32xximage -a $(CONFIG_SPL_TEXT_BASE)
1491
1492lpc32xx-spl.img: spl/u-boot-spl.bin FORCE
1493 $(call if_changed,mkimage)
1494
1495OBJCOPYFLAGS_lpc32xx-boot-0.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1496
1497lpc32xx-boot-0.bin: lpc32xx-spl.img FORCE
1498 $(call if_changed,objcopy)
1499
1500OBJCOPYFLAGS_lpc32xx-boot-1.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1501
1502lpc32xx-boot-1.bin: lpc32xx-spl.img FORCE
1503 $(call if_changed,objcopy)
1504
1505lpc32xx-full.bin: lpc32xx-boot-0.bin lpc32xx-boot-1.bin u-boot.img FORCE
1506 $(call if_changed,cat)
1507
1508endif
1509
1510OBJCOPYFLAGS_u-boot-with-tpl.bin = -I binary -O binary \
1511 --pad-to=$(CONFIG_TPL_PAD_TO)
1512tpl/u-boot-with-tpl.bin: tpl/u-boot-tpl.bin u-boot.bin FORCE
1513 $(call if_changed,pad_cat)
1514
1515SPL: spl/u-boot-spl.bin FORCE
1516 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1517
1518ifeq ($(CONFIG_ARCH_IMX8M)$(CONFIG_ARCH_IMX8), y)
1519ifeq ($(CONFIG_SPL_LOAD_IMX_CONTAINER), y)
1520u-boot.cnt: u-boot.bin FORCE
1521 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1522
1523flash.bin: spl/u-boot-spl.bin u-boot.cnt FORCE
1524 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1525else
1526ifeq ($(CONFIG_BINMAN),y)
1527flash.bin: spl/u-boot-spl.bin $(INPUTS-y) FORCE
1528 $(call if_changed,binman)
1529 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1530else
1531flash.bin: spl/u-boot-spl.bin u-boot.itb FORCE
1532 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1533endif
1534endif
1535endif
1536
1537u-boot.uim: u-boot.bin FORCE
1538 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1539
1540u-boot-with-spl.imx u-boot-with-nand-spl.imx: SPL $(if $(CONFIG_OF_SEPARATE),u-boot.img,u-boot.uim) FORCE
1541 $(Q)$(MAKE) $(build)=arch/arm/mach-imx $@
1542
1543MKIMAGEFLAGS_u-boot.ubl = -n $(UBL_CONFIG) -T ublimage -e $(CONFIG_SYS_TEXT_BASE)
1544
1545u-boot.ubl: u-boot-with-spl.bin FORCE
1546 $(call if_changed,mkimage)
1547
1548MKIMAGEFLAGS_u-boot-spl.ais = -s -n $(if $(CONFIG_AIS_CONFIG_FILE), \
1549 $(srctree)/$(CONFIG_AIS_CONFIG_FILE:"%"=%),"/dev/null") \
1550 -T aisimage -e $(CONFIG_SPL_TEXT_BASE)
1551spl/u-boot-spl.ais: spl/u-boot-spl.bin FORCE
1552 $(call if_changed,mkimage)
1553
1554OBJCOPYFLAGS_u-boot.ais = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO)
1555u-boot.ais: spl/u-boot-spl.ais u-boot.img FORCE
1556 $(call if_changed,pad_cat)
1557
1558u-boot-signed.sb: u-boot.bin spl/u-boot-spl.bin
1559 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot-signed.sb
1560u-boot.sb: u-boot.bin spl/u-boot-spl.bin
1561 $(Q)$(MAKE) $(build)=arch/arm/cpu/arm926ejs/mxs u-boot.sb
1562
1563MKIMAGEFLAGS_u-boot-spl.img = -A $(ARCH) -T firmware -C none \
1564 -a $(CONFIG_SPL_TEXT_BASE) -e $(CONFIG_SPL_TEXT_BASE) -n XLOADER
1565spl/u-boot-spl.img: spl/u-boot-spl.bin FORCE
1566 $(call if_changed,mkimage)
1567
1568ifneq ($(CONFIG_ARCH_SOCFPGA),)
1569quiet_cmd_gensplx4 = GENSPLX4 $@
1570cmd_gensplx4 = $(OBJCOPY) -I binary -O binary --gap-fill=0x0 \
1571 --pad-to=$(CONFIG_SPL_PAD_TO) \
1572 spl/u-boot-spl.sfp spl/u-boot-spl.sfp && \
1573 cat spl/u-boot-spl.sfp spl/u-boot-spl.sfp \
1574 spl/u-boot-spl.sfp spl/u-boot-spl.sfp > $@ || { rm -f $@; false; }
1575spl/u-boot-splx4.sfp: spl/u-boot-spl.sfp FORCE
1576 $(call if_changed,gensplx4)
1577
1578quiet_cmd_socboot = SOCBOOT $@
1579cmd_socboot = cat spl/u-boot-splx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1580u-boot-with-spl.sfp: spl/u-boot-splx4.sfp u-boot.img FORCE
1581 $(call if_changed,socboot)
1582
1583quiet_cmd_gensplpadx4 = GENSPLPADX4 $@
1584cmd_gensplpadx4 = dd if=/dev/zero of=spl/u-boot-spl.pad bs=64 count=1024 ; \
1585 cat spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1586 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1587 spl/u-boot-spl.sfp spl/u-boot-spl.pad \
1588 spl/u-boot-spl.sfp spl/u-boot-spl.pad > $@ || \
1589 { rm -f $@ spl/u-boot-spl.pad; false; }
1590u-boot-spl-padx4.sfp: spl/u-boot-spl.sfp FORCE
1591 $(call if_changed,gensplpadx4)
1592
1593quiet_cmd_socnandboot = SOCNANDBOOT $@
1594cmd_socnandboot = cat u-boot-spl-padx4.sfp u-boot.img > $@ || { rm -f $@; false; }
1595u-boot-with-nand-spl.sfp: u-boot-spl-padx4.sfp u-boot.img FORCE
1596 $(call if_changed,socnandboot)
1597
1598endif
1599
1600ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1601u-boot-with-dtb.bin: u-boot.bin u-boot.dtb \
1602 $(if $(CONFIG_MPC85XX_HAVE_RESET_VECTOR), u-boot-br.bin) FORCE
1603 $(call if_changed,binman)
1604
1605ifeq ($(CONFIG_MPC85XX_HAVE_RESET_VECTOR),y)
1606OBJCOPYFLAGS_u-boot-br.bin := -O binary -j .bootpg -j .resetvec
1607u-boot-br.bin: u-boot FORCE
1608 $(call if_changed,objcopy)
1609endif
1610endif
1611
1612quiet_cmd_ldr = LD $@
1613cmd_ldr = $(LD) $(LDFLAGS_$(@F)) \
1614 $(filter-out FORCE,$^) -o $@
1615
1616ifdef CONFIG_X86
1617OBJCOPYFLAGS_u-boot-x86-start16.bin := -O binary -j .start16
1618u-boot-x86-start16.bin: u-boot FORCE
1619 $(call if_changed,objcopy)
1620
1621OBJCOPYFLAGS_u-boot-x86-reset16.bin := -O binary -j .resetvec
1622u-boot-x86-reset16.bin: u-boot FORCE
1623 $(call if_changed,objcopy)
1624
1625endif # CONFIG_X86
1626
1627OBJCOPYFLAGS_u-boot-app.efi := $(OBJCOPYFLAGS_EFI)
1628u-boot-app.efi: u-boot FORCE
1629 $(call if_changed,zobjcopy)
1630
1631u-boot.bin.o: u-boot.bin FORCE
1632 $(call if_changed,efipayload)
1633
1634u-boot-payload.lds: $(LDSCRIPT_EFI) FORCE
1635 $(call if_changed_dep,cpp_lds)
1636
1637# Rule to link the EFI payload which contains a stub and a U-Boot binary
1638quiet_cmd_u-boot_payload ?= LD $@
1639 cmd_u-boot_payload ?= $(LD) $(LDFLAGS_EFI_PAYLOAD) -o $@ \
1640 -T u-boot-payload.lds arch/x86/cpu/call32.o \
1641 lib/efi/efi.o lib/efi/efi_stub.o u-boot.bin.o \
1642 $(addprefix arch/$(ARCH)/lib/,$(EFISTUB))
1643
1644u-boot-payload: u-boot.bin.o u-boot-payload.lds FORCE
1645 $(call if_changed,u-boot_payload)
1646
1647OBJCOPYFLAGS_u-boot-payload.efi := $(OBJCOPYFLAGS_EFI)
1648u-boot-payload.efi: u-boot-payload FORCE
1649 $(call if_changed,zobjcopy)
1650
1651u-boot-img.bin: spl/u-boot-spl.bin u-boot.img FORCE
1652 $(call if_changed,cat)
1653
1654#Add a target to create boot binary having SPL binary in PBI format
1655#concatenated with u-boot binary. It is need by PowerPC SoC having
1656#internal SRAM <= 512KB.
1657MKIMAGEFLAGS_u-boot-spl.pbl = -n $(srctree)/$(CONFIG_SYS_FSL_PBL_RCW:"%"=%) \
1658 -R $(srctree)/$(CONFIG_SYS_FSL_PBL_PBI:"%"=%) -T pblimage \
1659 -A $(ARCH) -a $(CONFIG_SPL_TEXT_BASE)
1660
1661spl/u-boot-spl.pbl: spl/u-boot-spl.bin FORCE
1662 $(call if_changed,mkimage)
1663
1664ifeq ($(ARCH),arm)
1665UBOOT_BINLOAD := u-boot.img
1666else
1667ifeq ($(CONFIG_MPC85xx)$(CONFIG_OF_SEPARATE),yy)
1668UBOOT_BINLOAD := u-boot-with-dtb.bin
1669else
1670UBOOT_BINLOAD := u-boot.bin
1671endif
1672endif
1673
1674OBJCOPYFLAGS_u-boot-with-spl-pbl.bin = -I binary -O binary --pad-to=$(CONFIG_SPL_PAD_TO) \
1675 --gap-fill=0xff
1676
1677u-boot-with-spl-pbl.bin: spl/u-boot-spl.pbl $(UBOOT_BINLOAD) FORCE
1678 $(call if_changed,pad_cat)
1679
1680# PPC4xx needs the SPL at the end of the image, since the reset vector
1681# is located at 0xfffffffc. So we can't use the "u-boot-img.bin" target
1682# and need to introduce a new build target with the full blown U-Boot
1683# at the start padded up to the start of the SPL image. And then concat
1684# the SPL image to the end.
1685
1686OBJCOPYFLAGS_u-boot-img-spl-at-end.bin := -I binary -O binary \
1687 --pad-to=$(CONFIG_UBOOT_PAD_TO) --gap-fill=0xff
1688u-boot-img-spl-at-end.bin: u-boot.img spl/u-boot-spl.bin FORCE
1689 $(call if_changed,pad_cat)
1690
1691quiet_cmd_u-boot-elf ?= LD $@
1692 cmd_u-boot-elf ?= $(LD) u-boot-elf.o -o $@ \
1693 -T u-boot-elf.lds --defsym=$(CONFIG_PLATFORM_ELFENTRY)=$(CONFIG_SYS_TEXT_BASE) \
1694 -Ttext=$(CONFIG_SYS_TEXT_BASE)
1695u-boot.elf: u-boot.bin u-boot-elf.lds
1696 $(Q)$(OBJCOPY) -I binary $(PLATFORM_ELFFLAGS) $< u-boot-elf.o
1697 $(call if_changed,u-boot-elf)
1698
1699u-boot-elf.lds: arch/u-boot-elf.lds prepare FORCE
1700 $(call if_changed_dep,cpp_lds)
1701
1702# MediaTek's ARM-based u-boot needs a header to contains its load address
1703# which is parsed by the BootROM.
1704# If the SPL build is enabled, the header will be added to the spl binary,
1705# and the spl binary and the u-boot.img will be combined into one file.
1706# Otherwise the header will be added to the u-boot.bin directly.
1707
1708ifeq ($(CONFIG_SPL),y)
1709spl/u-boot-spl-mtk.bin: spl/u-boot-spl
1710
1711u-boot-mtk.bin: u-boot-with-spl.bin
1712 $(call if_changed,copy)
1713else
1714MKIMAGEFLAGS_u-boot-mtk.bin = -T mtk_image \
1715 -a $(CONFIG_SYS_TEXT_BASE) -e $(CONFIG_SYS_TEXT_BASE) \
1716 -n "$(patsubst "%",%,$(CONFIG_MTK_BROM_HEADER_INFO))"
1717
1718u-boot-mtk.bin: u-boot.bin FORCE
1719 $(call if_changed,mkimage)
1720endif
1721
1722quiet_cmd_endian_swap = SWAP $@
1723 cmd_endian_swap = $(srctree)/tools/endian-swap.py $< $@
1724
1725u-boot-swap.bin: u-boot.bin FORCE
1726 $(call if_changed,endian_swap)
1727
1728ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(ARCH)/Makefile.postlink)
1729
1730# Generate linker list symbols references to force compiler to not optimize
1731# them away when compiling with LTO
1732ifdef CONFIG_LTO
1733u-boot-keep-syms-lto := keep-syms-lto.o
1734u-boot-keep-syms-lto_c := $(patsubst %.o,%.c,$(u-boot-keep-syms-lto))
1735
1736quiet_cmd_keep_syms_lto = KSL $@
1737 cmd_keep_syms_lto = \
1738 $(srctree)/scripts/gen_ll_addressable_symbols.sh $(NM) $^ > $@
1739
1740quiet_cmd_keep_syms_lto_cc = KSLCC $@
1741 cmd_keep_syms_lto_cc = \
1742 $(CC) $(filter-out $(LTO_CFLAGS),$(c_flags)) -c -o $@ $<
1743
1744$(u-boot-keep-syms-lto_c): $(u-boot-main)
1745 $(call if_changed,keep_syms_lto)
1746$(u-boot-keep-syms-lto): $(u-boot-keep-syms-lto_c)
1747 $(call if_changed,keep_syms_lto_cc)
1748else
1749u-boot-keep-syms-lto :=
1750endif
1751
1752# Rule to link u-boot
1753# May be overridden by arch/$(ARCH)/config.mk
1754ifdef CONFIG_LTO
1755quiet_cmd_u-boot__ ?= LTO $@
1756 cmd_u-boot__ ?= \
1757 $(CC) -nostdlib -nostartfiles \
1758 $(LTO_FINAL_LDFLAGS) $(c_flags) \
1759 $(KBUILD_LDFLAGS:%=-Wl,%) $(LDFLAGS_u-boot:%=-Wl,%) -o $@ \
1760 -T u-boot.lds $(u-boot-init) \
1761 -Wl,--whole-archive \
1762 $(u-boot-main) \
1763 $(u-boot-keep-syms-lto) \
1764 $(PLATFORM_LIBS) \
1765 -Wl,--no-whole-archive \
1766 -Wl,-Map,u-boot.map; \
1767 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1768else
1769quiet_cmd_u-boot__ ?= LD $@
1770 cmd_u-boot__ ?= $(LD) $(KBUILD_LDFLAGS) $(LDFLAGS_u-boot) -o $@ \
1771 -T u-boot.lds $(u-boot-init) \
1772 --whole-archive \
1773 $(u-boot-main) \
1774 --no-whole-archive \
1775 $(PLATFORM_LIBS) -Map u-boot.map; \
1776 $(if $(ARCH_POSTLINK), $(MAKE) -f $(ARCH_POSTLINK) $@, true)
1777endif
1778
1779quiet_cmd_smap = GEN common/system_map.o
1780cmd_smap = \
1781 smap=`$(call SYSTEM_MAP,u-boot) | \
1782 awk '$$2 ~ /[tTwW]/ {printf $$1 $$3 "\\\\000"}'` ; \
1783 $(CC) $(c_flags) -DSYSTEM_MAP="\"$${smap}\"" \
1784 -c $(srctree)/common/system_map.c -o common/system_map.o
1785
1786u-boot: $(u-boot-init) $(u-boot-main) $(u-boot-keep-syms-lto) u-boot.lds FORCE
1787 +$(call if_changed,u-boot__)
1788ifeq ($(CONFIG_KALLSYMS),y)
1789 $(call cmd,smap)
1790 $(call cmd,u-boot__) common/system_map.o
1791endif
1792
1793ifeq ($(CONFIG_RISCV),y)
1794 @tools/prelink-riscv $@ 0
1795endif
1796
1797quiet_cmd_sym ?= SYM $@
1798 cmd_sym ?= $(OBJDUMP) -t $< > $@
1799u-boot.sym: u-boot FORCE
1800 $(call if_changed,sym)
1801
1802# The actual objects are generated when descending,
1803# make sure no implicit rule kicks in
1804$(sort $(u-boot-init) $(u-boot-main)): $(u-boot-dirs) ;
1805
1806# Handle descending into subdirectories listed in $(u-boot-dirs)
1807# Preset locale variables to speed up the build process. Limit locale
1808# tweaks to this spot to avoid wrong language settings when running
1809# make menuconfig etc.
1810# Error messages still appears in the original language
1811
1812PHONY += $(u-boot-dirs)
1813$(u-boot-dirs): prepare scripts
1814 $(Q)$(MAKE) $(build)=$@
1815
1816tools: prepare
1817# The "tools" are needed early
1818$(filter-out tools, $(u-boot-dirs)): tools
1819# The "examples" conditionally depend on U-Boot (say, when USE_PRIVATE_LIBGCC
1820# is "yes"), so compile examples after U-Boot is compiled.
1821examples: $(filter-out examples, $(u-boot-dirs))
1822
1823define filechk_uboot.release
1824 echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
1825endef
1826
1827# Store (new) UBOOTRELEASE string in include/config/uboot.release
1828include/config/uboot.release: include/config/auto.conf FORCE
1829 $(call filechk,uboot.release)
1830
1831
1832# Things we need to do before we recursively start building the kernel
1833# or the modules are listed in "prepare".
1834# A multi level approach is used. prepareN is processed before prepareN-1.
1835# archprepare is used in arch Makefiles and when processed asm symlink,
1836# version.h and scripts_basic is processed / created.
1837
1838# Listed in dependency order
1839PHONY += prepare archprepare prepare0 prepare1 prepare2 prepare3
1840
1841# prepare3 is used to check if we are building in a separate output directory,
1842# and if so do:
1843# 1) Check that make has not been executed in the kernel src $(srctree)
1844prepare3: include/config/uboot.release
1845ifneq ($(KBUILD_SRC),)
1846 @$(kecho) ' Using $(srctree) as source for U-Boot'
1847 $(Q)if [ -f $(srctree)/.config -o -d $(srctree)/include/config ]; then \
1848 echo >&2 " $(srctree) is not clean, please run 'make mrproper'"; \
1849 echo >&2 " in the '$(srctree)' directory.";\
1850 /bin/false; \
1851 fi;
1852endif
1853
1854# prepare2 creates a makefile if using a separate output directory
1855prepare2: prepare3 outputmakefile cfg
1856
1857prepare1: prepare2 $(version_h) $(timestamp_h) $(dt_h) \
1858 include/config/auto.conf
1859ifeq ($(wildcard $(LDSCRIPT)),)
1860 @echo >&2 " Could not find linker script."
1861 @/bin/false
1862endif
1863
1864ifeq ($(CONFIG_USE_DEFAULT_ENV_FILE),y)
1865prepare1: $(defaultenv_h)
1866
1867envtools: $(defaultenv_h)
1868endif
1869
1870archprepare: prepare1 scripts_basic
1871
1872prepare0: archprepare FORCE
1873 $(Q)$(MAKE) $(build)=.
1874
1875# All the preparing..
1876prepare: prepare0
1877
1878# Generate some files
1879# ---------------------------------------------------------------------------
1880
1881# Use sed to remove leading zeros from PATCHLEVEL to avoid using octal numbers
1882define filechk_version.h
1883 (echo \#define PLAIN_VERSION \"$(UBOOTRELEASE)\"; \
1884 echo \#define U_BOOT_VERSION \"U-Boot \" PLAIN_VERSION; \
1885 echo \#define U_BOOT_VERSION_NUM $(VERSION); \
1886 echo \#define U_BOOT_VERSION_NUM_PATCH $$(echo $(PATCHLEVEL) | \
1887 sed -e "s/^0*//"); \
1888 echo \#define CC_VERSION_STRING \"$$(LC_ALL=C $(CC) --version | head -n 1)\"; \
1889 echo \#define LD_VERSION_STRING \"$$(LC_ALL=C $(LD) --version | head -n 1)\"; )
1890endef
1891
1892# The SOURCE_DATE_EPOCH mechanism requires a date that behaves like GNU date.
1893# The BSD date on the other hand behaves different and would produce errors
1894# with the misused '-d' switch. Respect that and search a working date with
1895# well known pre- and suffixes for the GNU variant of date.
1896define filechk_timestamp.h
1897 (if test -n "$${SOURCE_DATE_EPOCH}"; then \
1898 SOURCE_DATE="@$${SOURCE_DATE_EPOCH}"; \
1899 DATE=""; \
1900 for date in gdate date.gnu date; do \
1901 $${date} -u -d "$${SOURCE_DATE}" >/dev/null 2>&1 && DATE="$${date}"; \
1902 done; \
1903 if test -n "$${DATE}"; then \
1904 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_DATE "%b %d %C%y"'; \
1905 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TIME "%T"'; \
1906 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_TZ "%z"'; \
1907 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
1908 LC_ALL=C $${DATE} -u -d "$${SOURCE_DATE}" +'#define U_BOOT_EPOCH %s'; \
1909 else \
1910 return 42; \
1911 fi; \
1912 else \
1913 LC_ALL=C date +'#define U_BOOT_DATE "%b %d %C%y"'; \
1914 LC_ALL=C date +'#define U_BOOT_TIME "%T"'; \
1915 LC_ALL=C date +'#define U_BOOT_TZ "%z"'; \
1916 LC_ALL=C date +'#define U_BOOT_BUILD_DATE 0x%Y%m%d'; \
1917 LC_ALL=C date +'#define U_BOOT_EPOCH %s'; \
1918 fi)
1919endef
1920
1921define filechk_defaultenv.h
1922 ( { grep -v '^#' | grep -v '^$$' || true ; echo '' ; } | \
1923 tr '\n' '\0' | \
1924 sed -e 's/\\\x0\s*//g' | \
1925 xxd -i ; )
1926endef
1927
1928define filechk_dt.h
1929 (if test -n "$${DEVICE_TREE}"; then \
1930 echo \#define DEVICE_TREE \"$(DEVICE_TREE)\"; \
1931 else \
1932 echo \#define DEVICE_TREE CONFIG_DEFAULT_DEVICE_TREE; \
1933 fi)
1934endef
1935
1936$(version_h): include/config/uboot.release FORCE
1937 $(call filechk,version.h)
1938
1939$(timestamp_h): $(srctree)/Makefile FORCE
1940 $(call filechk,timestamp.h)
1941
1942$(dt_h): $(srctree)/Makefile FORCE
1943 $(call filechk,dt.h)
1944
1945$(defaultenv_h): $(CONFIG_DEFAULT_ENV_FILE:"%"=%) FORCE
1946 $(call filechk,defaultenv.h)
1947
1948# ---------------------------------------------------------------------------
1949# Devicetree files
1950
1951ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/boot/dts/),)
1952dtstree := arch/$(SRCARCH)/boot/dts
1953endif
1954
1955ifneq ($(dtstree),)
1956
1957%.dtb: prepare3 scripts_dtc
1958 $(Q)$(MAKE) $(build)=$(dtstree) $(dtstree)/$@
1959
1960PHONY += dtbs dtbs_install
1961dtbs: prepare3 scripts_dtc
1962 $(Q)$(MAKE) $(build)=$(dtstree)
1963
1964dtbs_install:
1965 $(Q)$(MAKE) $(dtbinst)=$(dtstree)
1966
1967ifdef CONFIG_OF_EARLY_FLATTREE
1968all: dtbs
1969endif
1970
1971endif
1972
1973PHONY += scripts_dtc
1974scripts_dtc: scripts_basic
1975 $(Q)$(MAKE) $(build)=scripts/dtc
1976
1977# ---------------------------------------------------------------------------
1978quiet_cmd_cpp_lds = LDS $@
1979cmd_cpp_lds = $(CPP) -Wp,-MD,$(depfile) $(cpp_flags) $(LDPPFLAGS) \
1980 -D__ASSEMBLY__ -x assembler-with-cpp -std=c99 -P -o $@ $<
1981
1982u-boot.lds: $(LDSCRIPT) prepare FORCE
1983 $(call if_changed_dep,cpp_lds)
1984
1985spl/u-boot-spl.bin: spl/u-boot-spl
1986 @:
1987 $(SPL_SIZE_CHECK)
1988
1989spl/u-boot-spl-dtb.bin: spl/u-boot-spl
1990 @:
1991
1992spl/u-boot-spl-dtb.hex: spl/u-boot-spl
1993 @:
1994
1995spl/u-boot-spl: tools prepare \
1996 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb) \
1997 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_TPL_OF_PLATDATA),dts/dt.dtb)
1998 $(Q)$(MAKE) obj=spl -f $(srctree)/scripts/Makefile.spl all
1999
2000spl/sunxi-spl.bin: spl/u-boot-spl
2001 @:
2002
2003spl/sunxi-spl-with-ecc.bin: spl/sunxi-spl.bin
2004 @:
2005
2006spl/u-boot-spl.sfp: spl/u-boot-spl
2007 @:
2008
2009spl/boot.bin: spl/u-boot-spl
2010 @:
2011
2012tpl/u-boot-tpl.bin: tools prepare \
2013 $(if $(CONFIG_OF_SEPARATE)$(CONFIG_OF_EMBED)$(CONFIG_SPL_OF_PLATDATA),dts/dt.dtb)
2014 $(Q)$(MAKE) obj=tpl -f $(srctree)/scripts/Makefile.spl all
2015 $(TPL_SIZE_CHECK)
2016
2017TAG_SUBDIRS := $(patsubst %,$(srctree)/%,$(u-boot-dirs) include)
2018
2019FIND := find
2020FINDFLAGS := -L
2021
2022tags ctags:
2023 ctags -w -o ctags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2024 -name '*.[chS]' -print`
2025 ln -s ctags tags
2026
2027etags:
2028 etags -a -o etags `$(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) \
2029 -name '*.[chS]' -print`
2030cscope:
2031 $(FIND) $(FINDFLAGS) $(TAG_SUBDIRS) -name '*.[chS]' -print > \
2032 cscope.files
2033 @find $(TAG_SUBDIRS) -name '*.[chS]' -type l -print | \
2034 grep -xvf - cscope.files > cscope.files.no-symlinks; \
2035 mv cscope.files.no-symlinks cscope.files
2036 cscope -b -q -k
2037
2038SYSTEM_MAP = \
2039 $(NM) $1 | \
2040 grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' | \
2041 LC_ALL=C sort
2042System.map: u-boot
2043 @$(call SYSTEM_MAP,$<) > $@
2044
2045#########################################################################
2046
2047# ARM relocations should all be R_ARM_RELATIVE (32-bit) or
2048# R_AARCH64_RELATIVE (64-bit).
2049checkarmreloc: u-boot
2050 @RELOC="`$(CROSS_COMPILE)readelf -r -W $< | cut -d ' ' -f 4 | \
2051 grep R_A | sort -u`"; \
2052 if test "$$RELOC" != "R_ARM_RELATIVE" -a \
2053 "$$RELOC" != "R_AARCH64_RELATIVE"; then \
2054 echo "$< contains unexpected relocations: $$RELOC"; \
2055 false; \
2056 fi
2057
2058tools/version.h: include/version.h
2059 $(Q)mkdir -p $(dir $@)
2060 $(call if_changed,copy)
2061
2062envtools: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2063 $(Q)$(MAKE) $(build)=tools/env
2064
2065tools-only: export TOOLS_ONLY=y
2066tools-only: scripts_basic $(version_h) $(timestamp_h) tools/version.h
2067 $(Q)$(MAKE) $(build)=tools
2068
2069tools-all: export HOST_TOOLS_ALL=y
2070tools-all: envtools tools ;
2071
2072cross_tools: export CROSS_BUILD_TOOLS=y
2073cross_tools: tools ;
2074
2075.PHONY : CHANGELOG
2076CHANGELOG:
2077 git log --no-merges U-Boot-1_1_5.. | \
2078 unexpand -a | sed -e 's/\s\s*$$//' > $@
2079
2080#########################################################################
2081
2082###
2083# Cleaning is done on three levels.
2084# make clean Delete most generated files
2085# Leave enough to build external modules
2086# make mrproper Delete the current configuration, and all generated files
2087# make distclean Remove editor backup files, patch leftover files and the like
2088
2089# Directories & files removed with 'make clean'
2090CLEAN_DIRS += $(MODVERDIR) \
2091 $(foreach d, spl tpl, $(patsubst %,$d/%, \
2092 $(filter-out include, $(shell ls -1 $d 2>/dev/null))))
2093
2094CLEAN_FILES += include/bmp_logo.h include/bmp_logo_data.h tools/version.h \
2095 boot* u-boot* MLO* SPL System.map fit-dtb.blob* \
2096 u-boot-ivt.img.log u-boot-dtb.imx.log SPL.log u-boot.imx.log \
2097 lpc32xx-* bl31.c bl31.elf bl31_*.bin image.map tispl.bin* \
2098 idbloader.img flash.bin flash.log defconfig keep-syms-lto.c
2099
2100# Directories & files removed with 'make mrproper'
2101MRPROPER_DIRS += include/config include/generated spl tpl \
2102 .tmp_objdiff doc/output include/asm
2103
2104# Remove include/asm symlink created by U-Boot before v2014.01
2105MRPROPER_FILES += .config .config.old include/autoconf.mk* include/config.h \
2106 ctags etags tags TAGS cscope* GPATH GTAGS GRTAGS GSYMS \
2107 drivers/video/fonts/*.S include/asm
2108
2109# clean - Delete most, but leave enough to build external modules
2110#
2111clean: rm-dirs := $(CLEAN_DIRS)
2112clean: rm-files := $(CLEAN_FILES)
2113
2114clean-dirs := $(foreach f,$(u-boot-alldirs),$(if $(wildcard $(srctree)/$f/Makefile),$f))
2115
2116clean-dirs := $(addprefix _clean_, $(clean-dirs))
2117
2118PHONY += $(clean-dirs) clean archclean
2119$(clean-dirs):
2120 $(Q)$(MAKE) $(clean)=$(patsubst _clean_%,%,$@)
2121
2122clean: $(clean-dirs)
2123 $(call cmd,rmdirs)
2124 $(call cmd,rmfiles)
2125 @find $(if $(KBUILD_EXTMOD), $(KBUILD_EXTMOD), .) $(RCS_FIND_IGNORE) \
2126 \( -name '*.[oas]' -o -name '*.ko' -o -name '.*.cmd' \
2127 -o -name '*.ko.*' -o -name '*.su' -o -name '*.pyc' \
2128 -o -name '.*.d' -o -name '.*.tmp' -o -name '*.mod.c' \
2129 -o -name '*.lex.c' -o -name '*.tab.[ch]' \
2130 -o -name '*.asn1.[ch]' \
2131 -o -name '*.symtypes' -o -name 'modules.order' \
2132 -o -name modules.builtin -o -name '.tmp_*.o.*' \
2133 -o -name 'dsdt.aml' -o -name 'dsdt.asl.tmp' -o -name 'dsdt.c' \
2134 -o -name '*.efi' -o -name '*.gcno' -o -name '*.so' \) \
2135 -type f -print | xargs rm -f
2136
2137# mrproper - Delete all generated files, including .config
2138#
2139mrproper: rm-dirs := $(wildcard $(MRPROPER_DIRS))
2140mrproper: rm-files := $(wildcard $(MRPROPER_FILES))
2141mrproper-dirs := $(addprefix _mrproper_,scripts)
2142
2143PHONY += $(mrproper-dirs) mrproper archmrproper
2144$(mrproper-dirs):
2145 $(Q)$(MAKE) $(clean)=$(patsubst _mrproper_%,%,$@)
2146
2147mrproper: clean $(mrproper-dirs)
2148 $(call cmd,rmdirs)
2149 $(call cmd,rmfiles)
2150 @rm -f arch/*/include/asm/arch
2151
2152# distclean
2153#
2154PHONY += distclean
2155
2156distclean: mrproper
2157 @find $(srctree) $(RCS_FIND_IGNORE) \
2158 \( -name '*.orig' -o -name '*.rej' -o -name '*~' \
2159 -o -name '*.bak' -o -name '#*#' -o -name '.*.orig' \
2160 -o -name '.*.rej' -o -name '*%' -o -name 'core' \
2161 -o -name '*.pyc' \) \
2162 -type f -print | xargs rm -f
2163 @rm -f boards.cfg CHANGELOG
2164
2165backup:
2166 F=`basename $(srctree)` ; cd .. ; \
2167 gtar --force-local -zcvf `LC_ALL=C date "+$$F-%Y-%m-%d-%T.tar.gz"` $$F
2168
2169help:
2170 @echo 'Cleaning targets:'
2171 @echo ' clean - Remove most generated files but keep the config'
2172 @echo ' mrproper - Remove all generated files + config + various backup files'
2173 @echo ' distclean - mrproper + remove editor backup and patch files'
2174 @echo ''
2175 @echo 'Configuration targets:'
2176 @$(MAKE) -f $(srctree)/scripts/kconfig/Makefile help
2177 @echo ''
2178 @echo 'Test targets:'
2179 @echo ''
2180 @echo ' check - Run all automated tests that use sandbox'
2181 @echo ' qcheck - Run quick automated tests that use sandbox'
2182 @echo ' tcheck - Run quick automated tests on tools'
2183 @echo ''
2184 @echo 'Other generic targets:'
2185 @echo ' all - Build all necessary images depending on configuration'
2186 @echo ' tests - Build U-Boot for sandbox and run tests'
2187 @echo '* u-boot - Build the bare u-boot'
2188 @echo ' dir/ - Build all files in dir and below'
2189 @echo ' dir/file.[oisS] - Build specified target only'
2190 @echo ' dir/file.lst - Build specified mixed source/assembly target only'
2191 @echo ' (requires a recent binutils and recent build (System.map))'
2192 @echo ' tags/ctags - Generate ctags file for editors'
2193 @echo ' etags - Generate etags file for editors'
2194 @echo ' cscope - Generate cscope index'
2195 @echo ' ubootrelease - Output the release version string (use with make -s)'
2196 @echo ' ubootversion - Output the version stored in Makefile (use with make -s)'
2197 @echo " cfg - Don't build, just create the .cfg files"
2198 @echo " envtools - Build only the target-side environment tools"
2199 @echo ''
2200 @echo 'Static analysers'
2201 @echo ' checkstack - Generate a list of stack hogs'
2202 @echo ' coccicheck - Execute static code analysis with Coccinelle'
2203 @echo ''
2204 @echo 'Documentation targets:'
2205 @$(MAKE) -f $(srctree)/doc/Makefile dochelp
2206 @echo ''
2207 @echo ' make V=0|1 [targets] 0 => quiet build (default), 1 => verbose build'
2208 @echo ' make V=2 [targets] 2 => give reason for rebuild of target'
2209 @echo ' make O=dir [targets] Locate all output files in "dir", including .config'
2210 @echo ' make C=1 [targets] Check all c source with $$CHECK (sparse by default)'
2211 @echo ' make C=2 [targets] Force check of all c source with $$CHECK'
2212 @echo ' make RECORDMCOUNT_WARN=1 [targets] Warn about ignored mcount sections'
2213 @echo ' make W=n [targets] Enable extra gcc checks, n=1,2,3 where'
2214 @echo ' 1: warnings which may be relevant and do not occur too often'
2215 @echo ' 2: warnings which occur quite often but may still be relevant'
2216 @echo ' 3: more obscure warnings, can most likely be ignored'
2217 @echo ' Multiple levels can be combined with W=12 or W=123'
2218 @echo ''
2219 @echo 'Execute "make" or "make all" to build all targets marked with [*] '
2220 @echo 'For further info see the ./README file'
2221
2222tests check:
2223 $(srctree)/test/run
2224
2225qcheck:
2226 $(srctree)/test/run quick
2227
2228tcheck:
2229 $(srctree)/test/run tools
2230
2231# Documentation targets
2232# ---------------------------------------------------------------------------
2233DOC_TARGETS := xmldocs latexdocs pdfdocs htmldocs epubdocs cleandocs \
2234 linkcheckdocs dochelp refcheckdocs
2235PHONY += $(DOC_TARGETS)
2236$(DOC_TARGETS): scripts_basic FORCE
2237 $(Q)$(MAKE) $(build)=doc $@
2238
2239PHONY += checkstack ubootrelease ubootversion
2240
2241checkstack:
2242 $(OBJDUMP) -d u-boot $$(find . -name u-boot-spl) | \
2243 $(PERL) $(src)/scripts/checkstack.pl $(ARCH)
2244
2245ubootrelease:
2246 @echo "$(UBOOTVERSION)$$($(CONFIG_SHELL) $(srctree)/scripts/setlocalversion $(srctree))"
2247
2248ubootversion:
2249 @echo $(UBOOTVERSION)
2250
2251# Single targets
2252# ---------------------------------------------------------------------------
2253# Single targets are compatible with:
2254# - build with mixed source and output
2255# - build with separate output dir 'make O=...'
2256# - external modules
2257#
2258# target-dir => where to store outputfile
2259# build-dir => directory in kernel source tree to use
2260
2261ifeq ($(KBUILD_EXTMOD),)
2262 build-dir = $(patsubst %/,%,$(dir $@))
2263 target-dir = $(dir $@)
2264else
2265 zap-slash=$(filter-out .,$(patsubst %/,%,$(dir $@)))
2266 build-dir = $(KBUILD_EXTMOD)$(if $(zap-slash),/$(zap-slash))
2267 target-dir = $(if $(KBUILD_EXTMOD),$(dir $<),$(dir $@))
2268endif
2269
2270%.s: %.c prepare scripts FORCE
2271 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2272%.i: %.c prepare scripts FORCE
2273 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2274%.o: %.c prepare scripts FORCE
2275 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2276%.lst: %.c prepare scripts FORCE
2277 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2278%.s: %.S prepare scripts FORCE
2279 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2280%.o: %.S prepare scripts FORCE
2281 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2282%.symtypes: %.c prepare scripts FORCE
2283 $(Q)$(MAKE) $(build)=$(build-dir) $(target-dir)$(notdir $@)
2284
2285# Modules
2286/: prepare scripts FORCE
2287 $(cmd_crmodverdir)
2288 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2289 $(build)=$(build-dir)
2290%/: prepare scripts FORCE
2291 $(cmd_crmodverdir)
2292 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2293 $(build)=$(build-dir)
2294%.ko: prepare scripts FORCE
2295 $(cmd_crmodverdir)
2296 $(Q)$(MAKE) KBUILD_MODULES=$(if $(CONFIG_MODULES),1) \
2297 $(build)=$(build-dir) $(@:.ko=.o)
2298 $(Q)$(MAKE) -f $(srctree)/scripts/Makefile.modpost
2299
2300quiet_cmd_genenv = GENENV $@
2301cmd_genenv = $(OBJCOPY) --dump-section .rodata.default_environment=$@ env/common.o; \
2302 sed --in-place -e 's/\x00/\x0A/g' $@
2303
2304u-boot-initial-env: u-boot.bin
2305 $(call if_changed,genenv)
2306
2307# Consistency checks
2308# ---------------------------------------------------------------------------
2309
2310PHONY += coccicheck
2311
2312coccicheck:
2313 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/$@
2314
2315# FIXME Should go into a make.lib or something
2316# ===========================================================================
2317
2318quiet_cmd_rmdirs = $(if $(wildcard $(rm-dirs)),CLEAN $(wildcard $(rm-dirs)))
2319 cmd_rmdirs = rm -rf $(rm-dirs)
2320
2321quiet_cmd_rmfiles = $(if $(wildcard $(rm-files)),CLEAN $(wildcard $(rm-files)))
2322 cmd_rmfiles = rm -f $(rm-files)
2323
2324# read all saved command lines
2325
2326cmd_files := $(wildcard .*.cmd)
2327
2328ifneq ($(cmd_files),)
2329 $(cmd_files): ; # Do not try to update included dependency files
2330 include $(cmd_files)
2331endif
2332
2333endif #ifeq ($(config-targets),1)
2334endif #ifeq ($(mixed-targets),1)
2335endif # skip-makefile
2336
2337PHONY += FORCE
2338FORCE:
2339
2340# Declare the contents of the PHONY variable as phony. We keep that
2341# information in a variable so we can use it in if_changed and friends.
2342.PHONY: $(PHONY)
This page took 0.056581 seconds and 4 git commands to generate.